#!/bin/bash


# implicitní hodnoty
nodu=2
jmeno=beh
logovani=0
vycisti=0
primy=0
pust=0
soubor=pokusne_behy_ks/53.xml
dalsipar="-keep-messages"

while [ $# -gt 0 ]; do
	case $1 in 
   	-j) jmeno=$2;shift 1;;
	-s) soubor=$2;shift 1;;
	-n) nodu=$2;
		if [[ -z "$2" ]] || ! [[ "$2" -gt 0 ]]; then
			echo "Počet uzlů by měl být kladné číslo, nikoliv $2"; exit 1;
		fi
		shift 1;;
	-l) export logovani=1;;
	-k) export primy=1;;
	-p) export pust=1;;
	-v) export vycisti=1;;
	-h) echo "Pustí na lokálním stroji centrum a 'nodu' nodu na zadání ze
souboru 'soubor', to vše v instanci GNU Screenu s jménem 'jmeno'.
	Syntaxe:
	./pust_paralelizovany.sh [parametry]
	-j 'jmeno'	— požadované jméno instance GNU Screenu (default: beh)
	-k 		— rozkopiruj primefily
	-p 		— proved spusteni
	-s 'soubor'	— XML soubor se zadáním
	-n 'nodu'	— požadovaný počet nodů (default: 2)
	-l		— logování
	-v 		— vymaže adresář pro běh, pokud již existuje
	-h		— vypsání nápovědy
"
	exit 0;;
	*) echo "Špatný parametr: $1";exit 1;;
	esac
	shift 1
done

cd ..
cesta="$(pwd)"
cd ..

echo "Jméno běhu:$jmeno"
echo "Soubor:$soubor"
echo "Počet nodů:$nodu"
echo "Cesta:$cesta"
echo -e "Logovani:$logovani\t Čištění:$vycisti\t Primefily:$primy\t Spust:$pust"

screeny=x$(screen -list $jmeno|head -c 5)

if [[ $screeny == xThere ]]; then
	echo "Skrin toho jmena uz bezi"
	exit 1
fi

if [ ! -f bin/$soubor ]; then
	echo "Soubor se zadáním nenalezen: $soubor";
	exit 1
fi

if [ ! "$nodu" -gt  0 ]; then
	echo "Špatné určení počtu nodů: $nodu";
	exit 1
fi

if [ -d bin/$jmeno ]; then
  if [ "x$vycisti" == "x1" ]; then
	rm -r bin/$jmeno
  else
	echo "Adresar jiz existuje, vymazejte rucne nebo zvolte vymazani"
	exit 1
  fi
fi

if [[ ! -f bin/primefil.fil ]] && [[ ! -f bin/primefil.bnd ]]; then
	echo "Nemohu kopirovat primefily - neexistuji"
	primy=0
fi

make -j 5 bin/ks

cd bin 
mkdir $jmeno
cd $jmeno

echo "Pouštím okno pro centrum $a"
mkdir comm cent
cp ../ks cent/center
cp ../$soubor cent/job.xml

if [[ "x$primy" == "x1" ]]; then
	echo "Kopiruji pripravene primefily"
	cp  ../primefil.* cent
fi

screen -d -m -S $jmeno -t cent 
sleep 2

for a in $(seq 1 $nodu); do
	echo "Pouštím okno pro uzel$a"
	mkdir $a
	cp ../ks $a/node
	if [[ "x$primy" == "x1" ]]; then
		cp  ../primefil.* $a
		echo "Kopiruji pripravene primefily"
	fi
	screen -S $jmeno -X screen -t ${a}
done

sleep 3

screen -S $jmeno -p cent -X stuff "cd cent
"
screen -S $jmeno -p cent -X stuff "ulimit -c unlimited
export CYGWIN=\"$CYGWIN error_start=dumper -d %1 %2\"
"
if [ "x$logovani" == "x1" ]; then
	screen -S $jmeno -p cent -X log
fi;
echo -e "#!/bin/sh \n ./center ${dalsipar} -id=cent -center -dst -conninfo=[file,file://${cesta}/$jmeno/comm/]" > cent/pust.sh
chmod +x "cent/pust.sh"

if [[ "x$pust" == "x1" ]]; then
	echo "Pouštím centrum"
	screen -S $jmeno -p cent -X stuff "./pust.sh
"
fi
screen -S $jmeno -p ${a} -X stuff "ulimit -c unlimited
export CYGWIN=\"$CYGWIN error_start=dumper -d %1 %2\"
";

for a in $(seq 1 $nodu); do
	if [ "x$logovani" == "x1" ]; then
		screen -S $jmeno -p ${a} -X log
	fi;

	screen -S $jmeno -p ${a} -X stuff "cd $a
"
	echo -e "#!/bin/sh\n ./node -node ${dalsipar} -id=node$a -centerinfo=[cent,file,file://${cesta}/$jmeno/comm,1000]" > "$a/pust.sh"
	chmod +x "$a/pust.sh"

	if [[ "x$pust" == "x1" ]]; then
		echo "Pouštím uzel $a"
		screen -S $jmeno -p ${a} -X stuff "./pust.sh
	"
	fi
done
