#include "algorithm_exception.h"
#include <stdio.h>

AlgorithmException::AlgorithmException(std::string aMessage, std::string aSourceName, int aLineNumber, int aParameter1, int aParameter2) : iMessage(aMessage), iSourceName(aSourceName), iLineNumber(aLineNumber), iParameter1(aParameter1), iParameter2(aParameter2)
{
	Print();
}

AlgorithmException::AlgorithmException(std::string aMessage, std::string aSourceName, int aLineNumber)  : iMessage(aMessage), iSourceName(aSourceName), iLineNumber(aLineNumber), iParameter1(0), iParameter2(0)
{
	Print();
}

AlgorithmException::AlgorithmException(const char* aMessage, const char* aSourceName, int aLineNumber, int aParameter1, int aParameter2) : iLineNumber(aLineNumber), iParameter1(aParameter1), iParameter2(aParameter2)
{
	if (aMessage)
	{
	iMessage.assign(aMessage);
	}
	if (aSourceName)
	{
	iSourceName.assign(aSourceName);
	}
	Print();
}

AlgorithmException::AlgorithmException(const char* aMessage, const char* aSourceName, int aLineNumber)  : iLineNumber(aLineNumber), iParameter1(0), iParameter2(0)
{
	
	if (aMessage)
	{
	iMessage.assign(aMessage);
	}
	if (aSourceName)
	{
	iSourceName.assign(aSourceName);
	}
	Print();
}


AlgorithmException::AlgorithmException(const AlgorithmException& aSource) : iMessage(aSource.iMessage), iSourceName(aSource.iSourceName), iLineNumber(aSource.iLineNumber), iParameter1(aSource.iParameter1), iParameter2(aSource.iParameter2)
{
	Print();
}

std::string		AlgorithmException::GetMessage() const
{
	return iMessage;
}

std::string		AlgorithmException::GetSourceName() const
{
	return iSourceName;
}

int			AlgorithmException::GetLineNumber() const
{
	return iLineNumber;
}


void	AlgorithmException::Print() const
{
	printf("\nAlgorithm Exception:\n");
	printf("Message:\t%s\n",iMessage.c_str());
	printf("Source :\t%s (line %d)\n",iSourceName.c_str(),iLineNumber);
	printf("Params :\t %d, %d\n",iParameter1,iParameter2);
}

