#ifndef ALGORITHM_EXCEPTION
#define ALGORITHM_EXCEPTION

#include <string>

/*!
 * \brief C++ exception class
 */
class AlgorithmException
{
public:
	AlgorithmException(std::string aMessage, std::string aSourceName, int aLineNumber, int aParameter1, int aParameter2);

	AlgorithmException(std::string aMessage, std::string aSourceName, int aLineNumber);

	AlgorithmException(const char* aMessage, const char* aSourceName, int aLineNumber, int aParameter1, int aParameter2);

	AlgorithmException(const char* aMessage, const char* aSourceName, int aLineNumber);

	AlgorithmException(const AlgorithmException& aSource);

	std::string		GetMessage() const;
	std::string		GetSourceName() const;
	int			GetLineNumber() const;

protected:
	void			Print() const;

private:
	std::string iMessage;
	std::string iSourceName;
	int	    iLineNumber;
	int	    iParameter1;
	int	    iParameter2;
};

#endif
