#include "gmp_factor.h"


/* globalni promenna pomahajici nastartovat nahodny generator */
extern gmp_randstate_t state;
/* do tohoto dynamickeho pole se kopiruji mala prvocisla pro ucely praktickych testu */
/* promenna pod nim obsahuje pocet polozek v poli small_primes MINUS jedna; tedy maximalni */
/* index v poli prvocisel */
extern long *small_primes;
extern long length_of_small_primes;

int initial_trial_factoring(divisor **factors, int *max_index, int *velikost_pole, mpz_t testednum)
{
	/* funkce prochazi dane cislo, postupne ho deli za pomoci trial division      */
	/* a zapisuje vysledky do pole **factors. ke dvojite referenci viz soubor *.h */
    
	char *jmeno,*jmeno_souboru1;
	FILE *fr;
	register int i,j=0;
	    
	if ((small_primes == NULL) || (length_of_small_primes==-1)) /* nemame-li pole s prvocisly v pameti ... */
	{
   	   if ((jmeno=(char *) malloc(13)) == NULL) /* ... zadefinujeme si promennou s nazvem souboru ... */
	   {
			printf("Not enough memory");
			return -5;
	   }
	   strcpy(jmeno,"primefil");
	   if ((jmeno_souboru1=(char *) malloc(13)) == NULL) /* ... zadefinujeme si promennou s nazvem souboru ... */
	   {
			printf("Not enough memory");
			free((void *) jmeno);
			return -5;
	   }
	   strcpy(jmeno_souboru1,"primefil.fil");
	   
       if ((fr=fopen(jmeno_souboru1,"rb"))!=NULL)  /* ... a pokud tento soubor neexistuje ... */
	   {                                           /* ... vytvorime si ho */
			fclose(fr);
	   }
	   /*else                                          
	   {			
    		generate_file_of_small_primes(jmeno,2,100000,0,0); 
	   }*/
													/* pokud existuhje*/
		/*printf("Kopirujeme prvocisla do pameti ..."); */
		copy_file_of_small_primes_into_memory(jmeno,100000);
		free((void *) jmeno);
		free((void *) jmeno_souboru1);
    }
	
	/* nyni uz muzeme bezpecne pocitat s tim, ze v pameti jsou prvocisla */
	
	if (!miller_rabin_test_pure(testednum,10,0,1)) /* pokud cislo je prvocislo */
	{	 
			if ((*max_index)==((*velikost_pole)-1))      /* zaplnili jsme cele dosavadni pole factors, */
			{	     
				/* musime si je realokovat; defaultne prodlouzime o 10 polozek */  
	     		*factors= ((divisor *) realloc((void *) *factors,((*velikost_pole)+10)*sizeof(divisor)));
				for (j=9;j>=0; j--)
					{
						mpz_init_set_ui((*(*factors+j+(*velikost_pole))).delitel,0);
					}
				*velikost_pole=(*velikost_pole)+10; /* pole se zvetsilo o 10 polozek */
			}	
			mpz_set((*(*factors+(*max_index)+1)).delitel,testednum);	/* zapiseme ho mezi faktory */
			(*(*factors+(*max_index)+1)).exponent=1;
			(*(*factors+(*max_index)+1)).typ_delitele=0;
			mpz_set_ui(testednum,1);
			(*max_index)++;
			return 0; /* a ukoncime test */
	}

	for (i=0;i<=length_of_small_primes;i++)
	{
		
		if ((*max_index)==((*velikost_pole)-1))  /* zaplnili jsme cele dosavadni pole factors, */
		{	                                   /* musime si je realokovat; defaultne prodlouzime o 10 polozek */
            
			*factors= (divisor *) realloc((void *) *factors,((*velikost_pole)+10)*sizeof(divisor));
		    
			for (j=9;j>=0; j--)
			{
				mpz_init_set_ui((*(*factors+j+(*velikost_pole))).delitel,0);
			}
			*velikost_pole=(*velikost_pole)+10; /* pole se zvetsilo o 10 polozek */
		}
		j=0;	
		while (mpz_divisible_ui_p(testednum,*(small_primes+i)))
		{
				mpz_divexact_ui(testednum,testednum,*(small_primes+i));
				j++;
		}
		if (j)  /* cislo bylo delitelne */
		{	    
			mpz_set_ui((*(*factors+(*max_index)+1)).delitel,*(small_primes+i));
		    (*(*factors+(*max_index)+1)).exponent=j;
			(*(*factors+(*max_index)+1)).typ_delitele=-1;
			(*max_index)++;
			/*printf("Maximalni index je ted %d, zapsali jsme delitel ",*max_index);
			mpz_out_str(NULL,10,(*(factors+(*max_index))).delitel);
			printf(" na %d-tou",(*( factors+(*max_index))).exponent);*/
			if (!mpz_cmp_ui(testednum,1)) return 0;
		}
	}
	
	if (!miller_rabin_test_pure(testednum,10,0,1)) /* pokud cislo, zbyle po vydeleni, je prvocislo */
	{	 
			if ((*max_index)==((*velikost_pole)-1))      /* zaplnili jsme cele dosavadni pole factors, */
			{	     
				/* musime si je realokovat; defaultne prodlouzime o 10 polozek */
                
				*factors= ((divisor *) realloc((void *) *factors,((*velikost_pole)+10)*sizeof(divisor)));
				for (j=9;j>=0; j--)
					{
						mpz_init_set_ui((*(*factors+j+(*velikost_pole))).delitel,0);
					}
				*velikost_pole=(*velikost_pole)+10; /* pole se zvetsilo o 10 polozek */
			}	
			mpz_set((*(*factors+(*max_index)+1)).delitel,testednum);	/* zapiseme ho mezi faktory */
			(*(*factors+(*max_index)+1)).exponent=1;
			(*(*factors+(*max_index)+1)).typ_delitele=0;
			mpz_set_ui(testednum,1);
			(*max_index)++;
			return 0; /* a ukoncime test */
	} 
/* na konci initial_trial_factoring je tedy pole, jehoz velikost je *velikost_pole, maximalni index s nejakym delitelem je *max_index */  
/* v testednum zbude to, co se nezdarilo vydelit */
}

/* tato funkce vrati nejvyssi cislo J tak, ze J<=k a J se v binarnim zapise sklada ze samych jednicek */

unsigned long maximal_lower_repunit(unsigned long *i, unsigned long k)
{
	int pomoc=2;
	*i=1;
	if ((k==1) || (k==2))
	{
		return 1;
	}
	while ((long) k/(pomoc-1))
	{
		pomoc=pomoc*2; (*i)++;
	}
    (*i)--;
	return ((long) pomoc/2-1);
    
}


int pollard_method_recursive(divisor **factors,int *max_index, int *velikost_pole, mpz_t testednum, mpz_t kolik)
{
/* budeme generovat pole indexovane longinty. zvolime si pocatecni hodnotu
	x_0 a budeme pocitat x_j=f(x_{j-1}), kde f je x^2+1. pritom,je-li binarni
	delka cisla j rovna k+1 cislicim, budeme pocitat GCD(x_j-x_{j_0}, testednum),
	kde x_{j_0} je cislo s indexem j_0=2^k-1 (nejvetsi (k)-bitove cislo) 
	funkce vraci 1, podarilo-li se ji behem "kolik" iteraci najit nejakeho delitele.
	funkce vraci 0, pokud nenalezla zadneho delitele
*/
/* zavaznym minusem Pollardovy metody je pouzity polynom. Mel by se pokud mozno
   chovat jako nahodna funkce, ale napr. x^2+a se tak "empiricky" nechova ani zhruba.

*/
	mpz_t pole_vysledku[100];
	/* toto budou hodnoty x_{j_0}. Zvolil jsem umyslne rozsah do 2^100, nebot
	   tolik operaci je jiz pocitacem nedosazitelnych. obsah na nultem indexu
	   se nevyuziva */
	mpz_t index,kolik2; /* index iterace, ktera se prave provadi */
	mpz_t pomocny,soucasna_iterace; /* sem se bude ukladat hodnota iterace */
	/* s promennou "pomocny" budeme provadet operace jako je GCD, do promenne */
	/* "soucasna_iterace" budeme ukladat pouze aktualni iteraci */
	int ktery=1,j,detektor_prvocisla=0,detektor_druheho_prvocisla=0; /* na kterem indexu jsme v tabulce pole_vysledku */
	mpz_t prislusne_cislo,foo; /* prislusne_cislo bude repunit 2^ktery-1, foo je 1 */
	register unsigned long i=0; /* size urcuje soucasnou velikost pole, i index, kde zrovna jsme */
	int flag_vypis=1;

	if (!mpz_cmp_ui(testednum,1)) return 0;
    
	mpz_init(pomocny);
	mpz_init_set_ui(soucasna_iterace,4);
	mpz_init(kolik2);
	mpz_init_set_ui(prislusne_cislo,1);
	mpz_init_set_ui(foo,1);
	
	/*mpz_urandomm(pomocny,state,testednum);*/
	for (i=0;i<=99;i++) mpz_init(pole_vysledku[i]);
	mpz_init(index);
	
	while (mpz_cmp(index,kolik)) /* dokud index neni rovno kolik */
	{
	    mpz_add_ui(index,index,1);
		mpz_powm_ui(soucasna_iterace,soucasna_iterace,2,testednum); /* evaluace polynomu x^2+1 mod N */
	    mpz_add_ui(soucasna_iterace,soucasna_iterace,5);
		mpz_mod(soucasna_iterace,soucasna_iterace,testednum); 
		mpz_set(pomocny,soucasna_iterace);
		
		if (!mpz_cmp(index,prislusne_cislo)) /* kdyz je index zrovna roven rep-unitu */ 
		{
			mpz_set(pole_vysledku[ktery],soucasna_iterace); /* zapiseme do prislusneho mista v tabulce hodnotu x_index*/
			ktery++;                                   /* zvysime patricne indexy */
			mpz_mul_ui(prislusne_cislo,prislusne_cislo,2);
			mpz_add_ui(prislusne_cislo,prislusne_cislo,1);
		}

		mpz_sub(pomocny,pole_vysledku[ktery],pomocny);
		mpz_gcd(pomocny,pomocny,testednum);
	/*	mpz_out_str(NULL,10,pomocny);*/
        if ((mpz_cmp(pomocny,testednum)) && (mpz_cmp_ui(pomocny,1)))/* nalezli jsme delitele */
		
		{
			if (flag_vypis)
			{
				printf("Nalezli jsme dva delitele cisla ");
				mpz_out_str(NULL,10,testednum);
				printf(". Jeden je ");
				mpz_out_str(NULL,10,pomocny);
				printf(", druhy je ");
			}

			mpz_divexact(testednum,testednum,pomocny);		
			if (flag_vypis)
			{
				mpz_out_str(NULL,10,testednum);
				printf(".");
			}

			if (!miller_rabin_test_pure(pomocny,10,0,1)) /* pokud cislo je prvocislo */
			{	 
				if ((*max_index)==((*velikost_pole)-1))      /* zaplnili jsme cele dosavadni pole factors, */
				{	     
					*factors= ((divisor *) realloc((void *) *factors,((*velikost_pole)+10)*sizeof(divisor)));
					for (j=9;j>=0; j--)
						{
							mpz_init_set_ui((*(*factors+j+(*velikost_pole))).delitel,0);
						}
					*velikost_pole=(*velikost_pole)+10; /* pole se zvetsilo o 10 polozek */
				}
			    if (flag_vypis)
				{
					printf("\nZjistili jsme, ze faktor ");
					mpz_out_str(NULL,10,pomocny);
					printf(" je prvocislo. Zapisujeme ho do seznamu faktoru ...");
				}
				mpz_set((*(*factors+(*max_index)+1)).delitel,pomocny);	/* zapiseme ho mezi faktory */
				(*(*factors+(*max_index)+1)).exponent=1;
				(*(*factors+(*max_index)+1)).typ_delitele=0;
				(*max_index)++;
				detektor_prvocisla=1;
			}
			if (!miller_rabin_test_pure(testednum,10,0,1)) /* pokud cislo je prvocislo */
			{	 
				if ((*max_index)==((*velikost_pole)-1))      /* zaplnili jsme cele dosavadni pole factors, */
				{	     
					*factors= ((divisor *) realloc((void *) *factors,((*velikost_pole)+10)*sizeof(divisor)));
					for (j=9;j>=0; j--)
						{
							mpz_init_set_ui((*(*factors+j+(*velikost_pole))).delitel,0);
						}
					*velikost_pole=(*velikost_pole)+10; /* pole se zvetsilo o 10 polozek */
				} else ; 
				if (flag_vypis)
				{
					printf("\nZjistili jsme, ze faktor ");
					mpz_out_str(NULL,10,testednum);
					printf(" je prvocislo. Zapisujeme ho do seznamu faktoru ...");
				}
				mpz_set((*(*factors+(*max_index)+1)).delitel,testednum);	/* zapiseme ho mezi faktory */
				(*(*factors+(*max_index)+1)).exponent=1;
				(*(*factors+(*max_index)+1)).typ_delitele=0;
				(*max_index)++;
				detektor_druheho_prvocisla=1;
			}
			if (detektor_prvocisla && detektor_druheho_prvocisla) 
			{
				if (flag_vypis)
				{
					printf("\nZjistili jsme dva prvociselne faktory, koncime tuto vetev.");
				}
						
				mpz_set_ui(testednum,1);
				return 0;
			}
			if (!detektor_prvocisla) /* pomocny neni prvocislo */
			{
				if (flag_vypis)
				{
					printf("\nSpoustime rekurzivni proces na cislo ");
					mpz_out_str(NULL,10,pomocny);
					printf("... Provedeme ");
					mpz_out_str(NULL,10,kolik);
					printf(" iteraci.");
				}
				if (pollard_method_recursive(factors,max_index,velikost_pole,pomocny,kolik))
				{	 
					if ((*max_index)==((*velikost_pole)-1))      /* zaplnili jsme cele dosavadni pole factors, */
					{	     
						*factors= ((divisor *) realloc((void *) *factors,((*velikost_pole)+10)*sizeof(divisor)));
						for (j=9;j>=0; j--)
							{
								mpz_init_set_ui((*(*factors+j+(*velikost_pole))).delitel,0);
							}
						*velikost_pole=(*velikost_pole)+10; /* pole se zvetsilo o 10 polozek */
					}	
					if (flag_vypis)
					{
						printf("Vime, ze cislo ");
						mpz_out_str(NULL,10,pomocny);
						printf(" je slozene, ale nenalezli jsme jeho delitele, a tak ho zapisujeme.");
					}
					mpz_set((*(*factors+(*max_index)+1)).delitel,pomocny);	/* zapiseme ho mezi faktory */
					(*(*factors+(*max_index)+1)).exponent=1;
					(*(*factors+(*max_index)+1)).typ_delitele=1;
					(*max_index)++;
					if (detektor_druheho_prvocisla) 
					{
						mpz_set_ui(testednum,1);
						return 0;
					}
				}
			}
			if (!detektor_druheho_prvocisla) /* testednum neni prvocislo */
			{
				if (flag_vypis)
				{
					printf("\nSpoustime rekurzivni proces na cislo ");
					mpz_out_str(NULL,10,testednum);
					printf("... Provedeme ");
					mpz_out_str(NULL,10,kolik);
					printf(" iteraci.");
				}
				
				if (pollard_method_recursive(factors,max_index,velikost_pole,testednum,kolik))
				{	 
					if ((*max_index)==((*velikost_pole)-1))      /* zaplnili jsme cele dosavadni pole factors, */
					{	     
						*factors= ((divisor *) realloc((void *) *factors,((*velikost_pole)+10)*sizeof(divisor)));
						for (j=9;j>=0; j--)
							{
								mpz_init_set_ui((*(*factors+j+(*velikost_pole))).delitel,0);
							}
						*velikost_pole=(*velikost_pole)+10; /* pole se zvetsilo o 10 polozek */
					}	
					if (flag_vypis)
					{
						printf("Vime, ze cislo ");
						mpz_out_str(NULL,10,testednum);
						printf(" je slozene, ale nenalezli jsme jeho delitele, a tak ho zapisujeme.");
					}
					mpz_set((*(*factors+(*max_index)+1)).delitel,testednum);	/* zapiseme ho mezi faktory */
					(*(*factors+(*max_index)+1)).exponent=1;
					(*(*factors+(*max_index)+1)).typ_delitele=1;
					(*max_index)++;
					mpz_set_ui(testednum,1);
					return 0;
					
				}
			}

		}
	} 	
	if (flag_vypis)
	{
		printf("Hledani dalsiho faktoru cisla ");
		mpz_out_str(NULL,10,testednum);
		printf(" skoncilo neuspechem.\n");
	}
	if (!mpz_cmp_ui(testednum,1)) return 0;
	return 1; /* nenalezli jsme zadne delitele */
}




void pollard_method(divisor **factors,int *max_index, int *velikost_pole, mpz_t testednum, mpz_t kolik)
{
	pollard_method_recursive(factors,max_index,velikost_pole,testednum,kolik);
	/*if (mpz_cmp_ui(testednum,1))
	{
        mpz_mul_ui(kolik,kolik,3);
		pollard_method_recursive(factors,max_index,velikost_pole,testednum,kolik);
	}*/
    if (mpz_cmp_ui(testednum,1))
	{

		if ((*max_index)==((*velikost_pole)-1))      /* zaplnili jsme cele dosavadni pole factors, */
				{	     
					/* musime si je realokovat; defaultne prodlouzime o 10 polozek */
	     			*factors= ((divisor *) realloc((void *) *factors,((*velikost_pole)+1)*sizeof(divisor)));
					mpz_init_set_ui((*(*factors+(*velikost_pole))).delitel,0);
					
					*velikost_pole=(*velikost_pole)+1; /* pole se zvetsilo o 10 polozek */
				}	
				mpz_set((*(*factors+(*max_index)+1)).delitel,testednum);	/* zapiseme ho mezi faktory */
				(*(*factors+(*max_index)+1)).exponent=1;
				(*(*factors+(*max_index)+1)).typ_delitele=miller_rabin_test_pure(testednum,10,0,1);
				(*max_index)++;
	}
	mpz_set_ui(testednum,1);
}



void factorize(divisor **factors,int *max_index, int *velikost_pole,mpz_t testednum, mpz_t kolik)
{
		
	
	initial_trial_factoring(factors, max_index, velikost_pole, testednum);
	if (mpz_cmp_ui(testednum,1)) pollard_method(factors, max_index, velikost_pole, testednum,kolik);

}


