#ifndef __GMP_FACTOR_H__
#define __GMP_FACTOR_H__

#include <stdio.h>
#include <stdlib.h>
#include "gmp.h"
#include "gmp_messages.h"
#include "time.h"
#include "gmp_tests.h"

extern "C" {

/* typ pro delitele */
/* exponent je maximalni exponent, s nimz se delitel nachazi v rozkladu cisla */

/*!
 * \brief divisor for initial trial division
 */
typedef struct {
    mpz_t delitel;
	long exponent;
	int typ_delitele; 
} divisor;

/* pole factors je potreba predavat dvojnasobnou referenci, protoze v prubehu
   faktorizace se muze vyskytnout potreba ho realokovat (zvetsit). kdybychom 
   predali pouze jednoduchy pointer, funkce realloc by ho zmenila, ale tato
   zmena by se nemohla projevit v nadrizenem procesu, nebot v C-cku se odkazy
   predavaji zasadne hodnotou
 */

int initial_trial_factoring(divisor **factors, int *max_index, int *velikost_pole, mpz_t testednum);
void pollard_method(divisor **factors,int *max_index, int *velikost_pole, mpz_t testednum, mpz_t kolik);
void factorize(divisor **factors,int *max_index, int *velikost_pole,mpz_t testednum, mpz_t kolik);
}

#endif

