/*!
	This method is used to calculate arg1*arg2 mod mod, where arg1 and arg2 are assumed to be 32-bit
	values. It uses an intermediate 64-bit variable, dependent on computer platform.

*/
inline int Mulm(INT64 arg1, INT64 arg2, int mod){
	INT64 inter =  arg1* arg2;
	//printf("Mulm soucin argumentu: %lld\n",inter);
	return (inter % mod);	
}

/*!
	This method is used to calculate arg1*arg2 mod mod, where arg1 and arg2 are assumed to be 32-bit
	values. It uses an intermediate 64-bit variable, dependent on computer platform.

*/
inline int Mulm(INT64 arg1, int arg2, int mod){
	INT64 inter =  arg1* (INT64) arg2;
	//printf("Mulm soucin argumentu: %lld\n",inter);
	return (inter % mod);	
}

/*!
	This method is used to calculate arg1*arg2 mod mod, where arg1 and arg2 are assumed to be 32-bit
	values. It uses an intermediate 64-bit variable, dependent on computer platform.

*/
inline int Mulm(int arg1, int arg2, int mod){
	INT64 inter = (INT64) arg1* (INT64) arg2;	
	//printf("Mulm soucin argumentu: %lld, mod %d: %lld.\n",inter, mod,(inter%mod));
	return (inter % mod);
}

/*!
	This method is used to calculate arg1^exp mod mod, where arg1 is are assumed to be 32-bit
	values. It uses an intermediate 64-bit variable, dependent on computer platform.
	A standard binary algorithm is used for calculation of powers.

*/
inline int Powm(int arg, int exp, int mod){
	if (!exp) return 0;
	if (exp == 1) return (arg%mod);	
	INT64 inter = (INT64) arg;	
        // nejprve zjistime maximalni jednickovy bit v cisle exp
	int i = -1;	
	while (exp >> (++i)){
	} 
	int max = i-1;  // nejvyssi signifikantni bit.
	int MASK = (1 << (max-1)); // zacneme od druheho nejvyssiho signifikatniho bitu
	while (MASK > 0){
		inter = Mulm(inter,inter,mod);
		if (exp & MASK) {
			inter = Mulm(inter,arg,mod);
		}
		MASK = MASK >> 1;
	}
	return (inter%mod);
}
