#ifndef __PARAMETER_TEST__
#define __PARAMETER_TEST__

#include "definitions.h"
#include "types.h"

#ifdef GNFS_LINE_SIEVING
#include "number_field_sieve.h"
#endif
#ifdef QS_LINE_SIEVING
#include "quadratic_sieve.h"
#include "qs_parameters.h"
#endif

/*!
 * \brief Testing QS implementation
 */
class ParameterTest 
{
public:

	ParameterTest();
#ifdef GNFS_LINE_SIEVING
	ParameterTest(nfs_basic_parameters& aParameters);
#endif
#ifdef QS_LINE_SIEVING
	ParameterTest(QSParameters& aParameters);
#endif

	int  Run(test_type aTestType);
	int  TestMemblock();
	void PrintResults();
	~ParameterTest();
private: 
	void Init();
#ifdef GNFS_LINE_SIEVING	
	nfs_basic_parameters iParameters;
	NumberFieldSieve*    iSieve;
#endif
#ifdef QS_LINE_SIEVING
	QSParameters	    iParameters;
	QuadraticSieve*	     iSieve;
#endif
	test_type	     iTestType;
	int*		     iValues;
	int		     iValuesMaxIndex;
	float*	             iResults;
	int		     iResultsMaxIndex;
};

#endif // __PARAMETER_TEST__

