#!/usr/bin/perl
#
# Vstupem tohoto programu jsou všechny soubory se zprávami v aktuálním
# adresáři. Program projde je všechny projde setřídí si je (od všech uzlů) do
# jednoho souboru a pak vytvoří graf, z kterého je patrné, jak postupně
# přibývaly parciální relace (od všech i součet).
# 

use vars qw/ %opt /;

sub init(){
	use Getopt::Std;
	my $opt_string = 'hvdm:p:c:z:';
	getopts("$opt_string",\%opt ) or usage();
	usage() if $opt{h};
}

sub usage(){
	
    print STDOUT << "EOF";

    Generátor grafů ze zpráv mezi centrem a nody a z výstupů do FrontendPipe	

    použití: $0 [parametr] ....

    -c centrum  :jméno centra (přednastaveno „centrum“)
    -d 		:zapnout dolaďování
    -d 		:zapnout dolaďování
    -h 		:vypíše tuto nápovědu
    -m adresář  :adresář se zprávami (přednastaven aktuální)
    -p soubor	:s výstupem FrontendPipe
    -v 		:vykecávání
    -z výběr	:výběr grafů, kombinace příznaků 
			k - komplet 
			n - nody (parciální) 
			s - suma (parciálních))
			h - suma (hladké)
			1 - suma (1-parciální)

EOF
   exit;
}

init();

my $adresar_zprav=".";
my $centrum_jmeno="centrum";
my $nody={};	

$adresar_zprav = $opt{m} if $opt{m};
$centrum= $opt{c} if $opt{c};
$fp= $opt{p} if $opt{p};

unless ($opt{z}) {
	$priznaky = "";
	$priznaky .= "ks" if $opt{p};
	$priznaky .= "ks1h" if $opt{m};
}
else {
	$priznaky = $opt{z};
};

if ($opt{v}) {
print STDOUT <<"EOF";
Adresář se zprávami		:$adresar_zprav
Jméno centra			:$centrum
Soubor s výstupem FrontendPipe	:$fp
Příznaky			:$priznaky
EOF
};


if ($opt{m}) {
opendir(LOCDIR,$adresar_zprav) || die ("Nemohu otevřít aktuální adresář.");
@soubory = readdir(LOCDIR);

open(DATA,">data.txt") || die ("Nemohu otevřít pomocný data.txt.");

my($soubor);
my($jmeno);
my($cislo);
my($inputline);

foreach $soubor (@soubory) {
	next unless $soubor =~ /(.*)_(.*)_.*fin/;
	print "\nZpracovávám $soubor" if $opt{d};
	$odesilatel = $2;
	$prijemce = $1;
	unless ($odesilatel eq $sodesilatel) {$cislo=-1;};
	$sodesilatel =$odesilatel;
	$cislo =-1;
	open(VSTUPAK,$adresar_zprav.$soubor);
	$inputline=<VSTUPAK>;
	do{
		if ($inputline =~ /<time seconds=.(\d*).*/) {
			$cas = $1;
		};
		if ($inputline =~ /<partial>======.*/) {
			$inputline=<VSTUPAK>;
			$inputline =~ /#(\d*)/;
			$cislo = $1;	
		};
	
	} while($inputline=<VSTUPAK>);
	close(VSTUPAK);
	if (($cislo != -1) && ($prijemce == $centrum)) {
		print DATA $cas.":".$odesilatel.":".$cislo.":".$comm."\n";
		print DATA $cas.":".$odesilatel.":".$cislo.":".$comm."\n" if $opt{d};
		$nody { $odesilatel } = 0;
	};

};

close(DATA);
closedir(LOCDIR);


open(DATA,"<data.txt") || die ("Nemohu otevřít vstupní soubor data.txt.");
open(DATA2,">data2.txt") || die ("Nemohu otevřít výstupní soubor data2.txt.");
open(DATAF,"<".$fp) || die ("Nemohu otevřít vstupní soubor s FP daty:".$fp);

my $soucet2=0;
my(@cely)=<DATA>;
@cely=sort(@cely);
foreach $inputline (@cely)
{
	$inputline =~ /([^:]*):([^:]*):([^:]*):/;	
	$cas = $1;
	$jmeno = $2;
	$cislo = $3;
	$nody{$2} = $3;
	print DATA2 "$cas ";
	$soucet = 0;
	for my $key (keys %nody) {
		my $value = $nody{$key};
		print DATA2 "$value ";
		$soucet=$soucet+$value;
	};
	print DATA2 "$soucet ";
	if ($fp) { while ($soucet > $soucet2) {
			last unless $input2 =<DATAF>;
			next unless $input2 =~  /PhaseSieve> \(\d*.\d*%\) \((\d*)\) \((\d*\)) \((\d*)\) \((\d*)\).*/;
			$dvaparc = $4;
			$komplet = $1;
			$hladke = $2;
			$jednaparc = $3;
			$soucet2 = $jednaparc+$dvaparc;
		} 	
		print DATA2 "$komplet $hladke $jednaparc $dvaparc";
	}
	print DATA2 "\n";
};
close(DATA);
close(DATA2);
close(DATAF);
} else
{
open(DATAF,"<".$fp) || die ("Nemohu otevřít vstupní soubor s FP daty:".$fp);
open(DATA2,">data2.txt") || die ("Nemohu otevřít vstupní soubor data2.txt.");
while ($input2 = <DATAF>){
	next unless $input2 =~  /PhaseSieve> \(\d*.\d*%\) \((\d*)\) \((\d*\)) \((\d*)\) \((\d*)\) \((\d*)\).*/;
	$dvaparc = $4;
	$komplet = $1;
	$hladke = $2;
	$jednaparc = $3;
	$cas = $5;
	$soucet2 = $jednaparc+$dvaparc;
	print DATA2 "$cas $soucet2 $komplet $hladke $jednaparc $dvaparc\n";
	};
close(DATA2);
close(DATAF);
}

my $vystup = "data2.txt";

open(GRAF,">graf.conf");
print GRAF "set timefmt \"%s\"\n";
print GRAF "set term png\n";
print GRAF "set ylabel \"Nasbíraných parciálních relací\"\n";
print GRAF "set xlabel \"Čas\"\n";
print GRAF "set format \"\%f\"\n";
print GRAF "set xdata time\n";
print GRAF "plot";
$carka = 0; 
if ($priznaky =~ /s/) {
	print GRAF " \"".$vystup."\" using 1:".(keys(%nody)+2)." title \"Dohromady parciálních\" with lines";
	$carka = 1;
}; 

if ($priznaky =~ /n/) {
	$iter = 2;
	for my $key (keys %nody) {
		print GRAF "," if ($carka ==1);
		print GRAF " \"".$vystup."\" using 1:$iter title \"$key\" with lines";
		$iter++;
		$carka = 1;
	};
};

if ($fp) { 
	if ($priznaky =~ /k/) {
		print GRAF "," if ($carka ==1) ;
		print GRAF " \"".$vystup."\" using 1:".(keys(%nody)+3)." title \"Kompletních relací\" with lines";
		$carka = 1;
	}; 
	if ($priznaky =~ /h/) {
		 print GRAF "," if ($carka ==1);
		print GRAF " \"".$vystup."\" using 1:".(keys(%nody)+4)." title \"Dohromady hladkých\" with lines";
		$carka = 1;
	}; 
	if ($priznaky =~ /1/) {
		print GRAF ","	if ($carka ==1) ;
		print GRAF " \"".$vystup."\" using 1:".(keys(%nody)+5)." title \"Dohromady 1-parciálních\" with lines";
		$carka = 1;
	};
};
print GRAF "\n";
close(GRAF);

qx/gnuplot <graf.conf>graf.png/;
		
