#ifndef __ALGORITHM_M__
#define __ALGORITHM_M__

#include "abstract_integer_matrix.h"

/*!
 * \brief Naive implementation of DLP solver using NFS
 */
class AlgorithmM {
public:
	AlgorithmM();
	~AlgorithmM();

	int SetMatrix(AbstractIntegerMatrix * aMatrix); ///< Set main matrix
	int ComputeBoundaries(); ///< Compute inner limits
	int Compute(long aLimit); ///< Main computation


	int Test();

private:
	AbstractIntegerMatrix *  main_matrix; ///< main matrix
	long rank; ///< rank of the main matrix
	long ETlogT; ///< limit on primes
	mpz_t E2TT; ///< limit on coefficients
};

#endif
