#ifndef __AUX_STRUCTURES_H__
#define __AUX_STRUCTURES_H__

#include "types_common.h"

/*!
  \file This file contains definitions of some auxiliary structures.
*/

/// Data structure for information about an error
struct error_context
{
	char* process; ///< Name of the process which has thrown the error.
	char* problem; ///< Short description of the encountered problem.
	int   errorCode; ///< An auxiliary numeric constant.
	int   label;  ///< An auxiliary numeric constant.
	char* sourceFile; ///< Name of the source file (e.g. "quadratic_sieve.cpp")
	char* explanation; ///< Probable reason of the encountered problem.
};

#endif