#ifndef __CENTERINFO_H__
#define __CENTERINFO_H__


#include "types_common.h"
#include <string>
#include <libxml/xmlreader.h>

using namespace std;

#include "connector_info.h"
#include "connectivity_framework_definitions.h"

/*!
 * \brief Specialized ConnecterInfo for distribution center
 */
class CenterInfo : public ConnectorInfo
{

public:	
	
 	CenterInfo(const char* aId, connector_type aConnection, const char* aAddress, unsigned int aTimeout);

	CenterInfo(string& aId, connector_type aConnection, string& aAddress, unsigned int aTimeout);

	~CenterInfo();

	const char*		GetId() 	const;
	unsigned int		GetTimeout() 	const;
	
	void			SetId(const char* aId);
	void			SetTimeout(unsigned int aTimeout);	

	void			Print() const;

	static CenterInfo*	Parse(const char* aInfo);
	static CenterInfo*	Deserialize(xmlTextReaderPtr& aReader);

	bool			IsEqual(const CenterInfo* aOtherInstance) const;


private:

	string			iId;
	unsigned int		iTimeout;
	
	
};
#endif
