#ifndef __CONST_RETURN_CODES_H_
#define __CONST_RETURN_CODES_H_

/*!
 * \brief Class of return codes
 *
	Should be used for all returned values.
*/
class ConstRC
{
public:

	static const int GoodCandidate;
	static const int EnoughSmooths;
	static const int Impropriate;
	static const int AlreadyExists;
	static const int All;

	static const int Ok;

	static const int NotEnoughMemory;
	static const int CouldNotOpenFile;
	static const int CouldNotCloseFile;
	static const int CouldNotReadFromNullStream;
	static const int EndOfFile;
	static const int BadArgument;
	static const int CouldNotWriteToNullStream;
	static const int GeneralError;
	// CBaseParameters error return codes
	static const int EntryExists;
	static const int NotFound;
	static const int CannotConvert;

	static const int Impossible;
	static const int CannotBeDone;
	static const int StopNow;
	static const int IncorrectDepth;
	static const int AlreadyRunning;

	static const int NegativeIndex;
	static const int ExcessiveRowIndex;
	static const int ExcessiveColumnIndex;

	static const int NullPointerSupplied;
	static const int SizeMismatch;
	
	static const int NotSpecified;
	static const int NotSupported;

	static const int Factorized;
	static const int NotFactorized;
	static const int NotEnoughSmooths;
	static const int SievingRegionExhausted;
	static const int InconsistentState;
	static const int FactorTooLarge;
	static const int PrimeTooLarge;

	static const int NoCandidates;
	static const int NotEnoughCandidates;
	
	static const int NeedEnlargement;
};

#endif // __CONST_RETURN_CODES_H_
