#ifndef __CRC32_H__
#define __CRC32_H__

#include <string>

using namespace std;

/*!
 * \brief Computing CRC32 check
 */
class Crc32
{
public:
	Crc32(const string& aFileName);
	~Crc32();
	unsigned int Count();
	
private:
	unsigned int Update(const char* aBuffer, unsigned int aLength);
	unsigned int Update(const char* aBuffer);	
	void	Reset();
	
private:
	string	iFileName;
	unsigned int iCrc;		
	static const unsigned int CrcTab[256];
};

#endif
