#ifndef __ENUMS_COMMON_H
#define __ENUMS_COMMON_H
/*!
	This enum is for used factorization algorithm that can be used to factor remainder after trial division.

	EFAEllipticCurve - is not supported
*/
enum supporting_factor_alg_types { EFAPollardRho = 0, EFASQUFOF, EFACFRAC, EFAPMinus1, EFAEllipticCurve};

enum line_sieve_size { ESizeUndefined = 0, ESize1k = 1024, ESize2k = 2048, ESize4k = 4096, ESize8k = 8192, ESize16k = 16384, ESize32k = 32768, ESize48k = 49152, ESize64k = 65536, ESize96k = 98304, ESize128k = 131072, ESize160k = 163840, ESize192k = 196608, ESize256k = 262144, ESize384k = 393216, ESize512k = 524288 };

/*!
 String formats of polynomial: Long - all coefficients, Short - only nonzero coefficients
*/
enum poly_str_formats { ELongFormat, EShortFormat };


/*!
 Species of matrix
*/
enum species_of_matrices  {SAbstractMatrix = 0, SNormalMatrix, SBitMatrix, SBCMatrix, SSparseMatrix};


/*!
 Type of MatrixSolver
*/
enum matrix_solver_type { ELanczos = 0 };

/*!
 Type of multiplication in Lanczos alg
*/
enum multi_type    { ENormalMul = 0, ETransposedMul };

/*!
 Types of endians
*/
enum endian_types { ENotDefine = 0, ELittleEndian, EBigEndian };


#endif
