#include "job_parameters.h"

const string  JobParameters::GetStringParameter(const string& aName) const
{
	return GetStringParameter(aName.c_str());
}


int      JobParameters::GetIntegerParameter(const string& aName) const
{
	return GetIntegerParameter(aName.c_str());
}

double      JobParameters::GetDoubleParameter(const string& aName) const
{
	return GetDoubleParameter(aName.c_str());
}

bool      JobParameters::GetBoolParameter(const string& aName) const
{
	return GetBoolParameter(aName.c_str());
}

int     JobParameters::GetMpzParameter(const string& aName, mpz_t aResult) const
{
	return GetMpzParameter(aName.c_str(), aResult);
}

distribution	JobParameters::Get_DistributionMachineType() const
{
return iDistributionMachineType;
}

string		JobParameters::Get_SharedURL() const
{
return iSharedURL;
}

string		JobParameters::Get_MachineName() const
{
return iMachineName;
}

int		JobParameters::Get_CommitInterval() const
{
return iCommitInterval;
}

void	JobParameters::Set_DistributionMachineType(distribution aValue)
{
iDistributionMachineType = aValue;
}

void	JobParameters::Set_SharedURL(const string& aValue)
{
iSharedURL.assign(aValue);
}

void	JobParameters::Set_SharedURL(const char* aValue)
{
	if (aValue != NULL)
	{
	iSharedURL.assign(aValue);
	}
	else
	{
	iSharedURL.assign("");
	}
}

void	JobParameters::Set_MachineName(const string& aValue)
{
iMachineName.assign(aValue);
}

void	JobParameters::Set_MachineName(const char* aValue)
{
	if (aValue != NULL)
	{
	iMachineName.assign(aValue);
	}
	else
	{
	iMachineName.assign("");
	}
}

void	JobParameters::Set_CommitInterval(int aValue)
{
iCommitInterval = aValue;
}

