#ifndef __LANCZOS_CLASS__
#define __LANCZOS_CLASS__

#include "abstract_matrix_solver.h"
#include "enums_common.h"

/*!
 * \brief Lanczos solver for Z_2
 */
class Lanczos : public AMatrixSolver
{
private:
	static const unsigned int LANCZOS_FULL_MASK = 0xffffffff;

public:
	Lanczos();
	Lanczos(species_of_matrices aType);
	Lanczos(species_of_matrices aType, multi_type aType2);
	~Lanczos();

	species_of_matrices GetAuxiliaryMatricesType() const;
	multi_type GetMultiType() const;
	void SetAuxiliaryMatricesType(species_of_matrices aType);
	void SetMultiType(multi_type aType);

	AbstractMatrix* NewMatrix(long aRow, long aCol);
	BitMatrix* Compute(AbstractMatrix* aMatrixB);
	
	

private:
	species_of_matrices iAuxiliaryMatricesType;
	multi_type iMultiType;
	// addresses of methods for multiplications
};

#endif
