#ifndef __NODE_INFO__
#define __NODE_INFO__

#include <string>
#include "connector_info.h"

using namespace std;

class AbstractMessage;

/*!
 * \brief Information on node
 */
class NodeInfo : public ConnectorInfo
{
public:
	// Constructor which parses an AbstractMessage to get nodeInfo
	NodeInfo(AbstractMessage* aMessage);
	~NodeInfo();

	const char*	GetId() const;

	bool	Identical(NodeInfo* aOtherNode);

	void	Set_Locked(); // Will set current time as iLockTime.
	void	Update_LastReceived(); // Will set current time as iLastMessageReceivedTime

	void	PrintInfo() const; // Prints out a short info.

	void	IncrementDataReceived(unsigned int aHowMuch);

	void	SetDataUnit(const string& aDataUnit);

protected:
	// Prints time "intelligently"
	static  void PrintTime(const time_t& aTime);

	static  bool IsToday(const time_t& aTime);

private:	

	string	iNodeId;

	bool	iLocked;
	
	time_t  iLockTime;
	
	time_t  iLastMessageReceivedTime;	

	unsigned int iDataReceivedCount;

	string	iDataUnit;
};

#endif

