#include "primitive_root.h"

#include <iostream>
#include <time.h>
#include <cstdlib>

bool CNumber::Prime()
{
	return prime;
}

void CNumber::Prime(bool b)
{
	prime=b;
}

void CNumber::Divide(int d)
{
	divisor=d;
}

int CNumber::Value()
{
	return n;
}

int CNumber::Divide()
{
	return divisor;
}

void CNumber::Add(unsigned int a)	//add divisor of n into decomposition
{
	decompos.push_back(a);
}

CNumber::CNumber()		//initialization
{
	prime=true;
	divisor=0;
	decompos.resize(0);
	n=0;
	primit=0;
}

void CNumber::Init(int n)	//value of the number setting
{
	this->n=n;
}

void CNumber::Primit(int primit)
{
	this->primit=primit;
}

int CNumber::Primit()
{
	return this->primit;
}

int CNumber::DecompLength()		//length of decomposition
{
	return decompos.size();
}

int CNumber::Decomp(int i)
{
	return decompos[i];
}

void CNumber::PrintPrimit()		//printout
{
	if (prime)
	{
		std::cout<<" Prime:"<<n<<"\tPrimitive:"<<primit<<std::endl;
	}
}

void CNumber::Print()		//testing printout
{
	std::cout<<n<<"\t"<<prime<<" "<<divisor<<" #"<<primit<<"# {";
	for (unsigned int i=0; i<decompos.size(); i++)
	{
		if (i!=0)
			std::cout<<",";
		std::cout<<decompos[i];
	}
	std::cout<<"}"<<std::endl;
}

CPrimitiveRoot::CPrimitiveRoot(int maxvalue)
{
	this->maxvalue=maxvalue;
}

int CPrimitiveRoot::Power(int base, int exponent, int mod)		//return base^exponent modulo mod
{
	long a=base;
	for (int i=1; i<exponent; i++)
	{
		a*=base;
		a%=mod;
	}
	return a;
}

void CPrimitiveRoot::CPrimitiveRootGenerator(std::vector<CNumber> & aField)
{
	std::vector<CNumber> field(maxvalue+1);		//intialization
	for (unsigned int i=0; i<aField.size(); i++)
	{
		aField[i].Init(i);						
	}										//end of initialization
	int n=2;
	while (n<=maxvalue)								//modified Erastotens sieve which into every not prime number add his divisor
	{
		while (!aField[n].Prime())					//find next prime in the field
		{
			if (n<maxvalue)
				n++;
			else
				break;
		}
		for (unsigned int i=2*n; i<aField.size(); i+=n)	//if number is not prime add his divisor and set value of variable prime into false
		{
			if(aField[i].Prime())
			{
				aField[i].Prime(false);
				aField[i].Divide(n);
			}
		}
		n++;
	}												//end of modified Erastotenes sieve
	int div;
	for (n=2; n<=maxvalue; n++)							//prime division finding (filling of array decomp) (not powers)
	{
		if (aField[n].Prime())		
		{
			aField[n].Add(n);
		}
		else
		{
			aField[n].Add(aField[n].Divide());	
			div=aField[n].Value()/aField[n].Divide();
			for (int i=0; i<aField[div].DecompLength();i++)
			{
				aField[n].Add(aField[div].Decomp(i));
			}
		}
	}													//now we have prime decomposition of every number (not powers)
	int random=0;						//randomizing
	bool primitive;
	srand (time(NULL));
	for (int i=2; i<=maxvalue; i++)			//trying primitivity for random numbers
	{
		if (!aField[i].Prime())				//finding next prime
		{
			continue;
		}
		primitive=false;
		while (!primitive)
		{
			random=(rand()%aField[i-1].Value())+1;		//random number
			primitive=true;
			for (int j=0; j<aField[i-1].DecompLength();j++)		//order of random number testing
			{													//testing all orders, which arise from (value-1)/p, where p is a prime from array decomp
				if (Power(random,(aField[i-1].Value()/aField[i-1].Decomp(j)),aField[i].Value())==1)
				{
					primitive=false;		//if order of the random number is less then value-1 it ends and try another one because it is not a primitive
					break;
				}
			}
		}
		aField[i].Primit(random);			//setting of primitive
	}
}
