#ifndef __PRIMITIVE_ROOT_H__
#define __PRIMITIVE_ROOT_H__

#include <vector>

/*!
 * \brief Auxiliary class for saving decomposed number
*/
class CNumber
{
	int			n;		//value of the number
	bool		prime;		//is prime or is not prime
	int			divisor;
	std::vector<int>	decompos;		//decomposition of n
	int			primit;

public: 
	bool Prime();
	void Prime(bool b);
	void Divide(int d);
	int Value();
	int Divide();
	///add divisor of n into decomposition
	void Add(unsigned int a);
		
	CNumber();
	///value of the number setting
	void Init(int n);
	void Primit(int primit);
	int Primit();
	///length of decomposition
	int DecompLength();
	int Decomp(int i);
	///printout
	void PrintPrimit();
	//testing printout
	void Print();
};


/*!
 * \brief Generating primitive root in a field
 */
class CPrimitiveRoot
{
	int maxvalue;

public:
	CPrimitiveRoot(int maxvalue);

	///return base^exponent modulo mod
	int Power(int base, int exponent, int mod);
	void CPrimitiveRootGenerator(std::vector<CNumber> & aField);
	
};



#endif // __PRIMITIVE_ROOT_H__
