#ifndef __SQUFOF_H__
#define __SQUFOF_H__

// #include "abstract_supporting_factor_alg.h"
#include "gmp.h"
#include "abstract_supporting_factor_alg.h"

/*!
 * \brief Simple implementation of SQUFOF algorithm
 */
class SQUFOF : public ASupportingFactorAlg 
{
public:
	SQUFOF();
	~SQUFOF();
	int Factor(mpz_t aModulus, mpz_t aFactor1, mpz_t aFactor2);
	bool sqrti(long & aTarget, long aSource);
	long gcd(long  aSource1, long aSource2);
	long gcd(long  aSource1, long aSource2, long aSource3);
	long Rfunction(long aDiscsquare, long aMB, long aC);
	int Reduce(long & aA, long & aB, long & aC, long aDiscsquare, long aDisc);
	bool Reduced(long aA, long aB, long aC, long aDiscsquare, long aDisc);
	int Test();

	mpz_t checkprod;
};

#endif // __SQUFOF_H__
