#ifndef __WRITE_READ_MUTEX_H__
#define __WRITE_READ_MUTEX_H__

#include <pthread.h>

/*!
 * \brief Mutex mechanism for sieves
 */
class CWriteReadMutex
{
private:
	int iMaxReaders;
	int iReadersCount;
	pthread_mutex_t iReadersCountMutex;
	pthread_mutex_t iWriteMutex;
	pthread_cond_t iReadersCountCond;

public:

	CWriteReadMutex();
	CWriteReadMutex(const int& aMaxReaders);
	CWriteReadMutex(const CWriteReadMutex& aOperand);
	~CWriteReadMutex();

	void LockRead();
	void UnlockRead();
	void LockWrite();
	void UnlockWrite();

	// GETTERS and SETTERS
	int Get_MaxReaders() const { return this->iMaxReaders; }
};

#endif // __WRITE_READ_MUTEX_H__
