#ifndef __XML_DEFINITIONS__
#define __XML_DEFINITIONS__

// Common definitions for MPQS/SIQS and NFS serialization


#define JOB_FILE "job.xml"
#define FB_FILE  "factor_base.xml"
#define SIEVING_FILE "sieving.xml"
#define SIEVER_STATE_FILE "siever_state.xml"

#define XML_ENCODING "ISO-8859-1"
#define JOB_DATA	   "job-data"
#define RESULT_DATA		"result"
#define SERIALIZATOR_NAME  "serializator"
# define SERIALIZATOR_ATTR_NAME	"name"
#define NAME 		   "name"
#define VERSION_NAME	   "version"
#define TIME_NAME	   "time"
#define SECONDS		   "seconds"
#define FORMATTED          "formatted"
#define TYPE		   "type"
#define MPZ		   "mpz"
#define STRING 		   "string"
#define VALUE		   "value"
#define BASE		   "base"
#define LENGTH		   "length"
#define SIGNED_INT	   "signed int"
#define SIGNED_LONG	   "signed long"
#define UNSIGNED_INT	   "unsigned int"
#define UNSIGNED_LONG	   "unsigned long"
#define DOUBLE             "double"
#define ALLOCATED_NAME	   "allocated"
#define MAX_INDEX_NAME	   "max_index"
#define DEGREE		   "degree"
#define PARAM_ENTRY    "param entry"
#define BOOLEAN_XML		   "boolean"
#define STRING		   "string"
#define BINARY_DATA    "binary data"
#define ENDIAN_TYPE	   "endian"
#define UNIT_LENGTH    "unit-length"
#define UNIT_COUNT	   "unit-count"
#define SIEVING_ELEMENT				"sieving-element"
#define INTEGER_FOR_SIEVING			"integer-for-sieving"
#define PRIME_IDEAL_FOR_SIEVING		"prime-ideal-for-sieving"
#define PRIME_IDEAL_FOR_LEGENDRE	"prime-ideal-for-legendre"
#define FB_ELEMENT					"fb-element"
#define	PRIMITIVE_ROOT				"primitive-root"
#define POWER_MOD_P					"power-mod-p"

#define MEMBLOCK_SIZE	   "memblock-size"

#define FACTOR_BASE_DATA   "factor-base-data"
#define COEFFICIENT_NAME   "coefficient"
#define POWER		   "power"
#define ROOT_NAME	   "root"
#define SIEVING_DATA 	   "sieving-data"
#define SIEVING_STATUS	   "sieving-status"
#define LINE_NUMBER	   "line-number"
#define RUNNING_NAME	   "running"
#define FINISHED_NAME	   "finished"
#define SIEVER_STATUS_DATA "siever-status-data"

#define MAXIMAL_PARTIAL_FACTOR_NAME "max-partial-factor"
#define VARIATIONS_NAME "variations"
#define SO_FAR_SMOOTHS_FOUND_NAME "smooths-found"
#define SO_FAR_1_PARTIALS_FOUND_NAME "one-partials-found"
#define SO_FAR_PARTIALS_FOUND_NAME "partials-found"
#define SO_FAR_2_PARTIALS_FOUND_NAME "two-partials-found"
#define SO_FAR_X_PARTIALS_FOUND_NAME "x-partials-found"
#define RELATION_PROCESSING_PHASE_NAME "relation-processing-phase"
#define RELATION_PROCESSING_FLAGS_NAME "relation-processing-flags"


#define DISTRIBUTED "distributed"
#define DISTRIBUTION_MACHINE_TYPE "distribution-machine-type"
#define CENTER "center"
#define NODE "node"
#define SHARED_URL "shared-url"
#define MACHINE_NAME "machine-name"
#define COMMIT_INTERVAL "commit-interval"
# define KEEP_MESSAGES "keep-messages"
# define CONNECTOR_INFOS "connectors"
# define CENTER_INFOS "centers"

#define START_TIME	"start-time"
#define STOP_TIME "stop-time"

#define INFO_MODE_NAME     "info-mode"
#define DEBUG_MODE_NAME    "debug-mode"

#endif

