#include "abstract_factor_alg.h"

int AFactorAlg::GenerateModulus(mpz_t aResult, int aFactor1Size, int aFactor2Size)
{
	mpz_t factor1;
	mpz_t factor2;

	mpz_init(factor1);
	mpz_init(factor2);

	int cifer = rand() % 9;
	cifer++;

	mpz_set_si(factor1, cifer);
	
	for (int i = 1; i < aFactor1Size; i++)
	{
		cifer = rand() % 10;
		mpz_mul_si(factor1, factor1, 10);
		mpz_add_ui(factor1, factor1, cifer);
	}

	cifer = rand() % 9;
	cifer++;

	mpz_set_si(factor2, cifer);

	for (int i = 1; i < aFactor2Size; i++)
	{
		cifer = rand() % 10;
		mpz_mul_si(factor2, factor2, 10);
		mpz_add_ui(factor2, factor2, cifer);
	}

	mpz_nextprime(factor1, factor1);
	mpz_nextprime(factor2, factor2);

	mpz_mul(aResult, factor1, factor2);

	mpz_clear(factor1);
	mpz_clear(factor2);

	return ConstRC::Ok;
}
