#ifndef __ABSTRACT_FACTOR_ALG_H__
#define __ABSTRACT_FACTOR_ALG_H__

#include "abstract_factor_alg_parameters.h"
#include "thread_pool.h"

///Abstract class for general factorization algorithm (QS, NFS)
class AFactorAlg : public virtual MSerializable
{
protected:
	///Thread pool
	CThreadPool* iThreadPool;
	///Parameters
	AFactorAlgParameters*  iParameters;
	
protected:

	///Init all parameters necessary for calculation - get from iParameters
	virtual int Initialization() = 0;

	///Clena up all used files
	virtual int CleanUp(AFactorAlgParameters * aParameters, bool aError) = 0;

	int GenerateModulus(mpz_t aResult, int aFactor1Size, int aFactor2Size);

public:

	virtual ~AFactorAlg() {}

	virtual int RunFactorization(AFactorAlgParameters * aParameters) = 0;

};


#endif // __ABSTRACT_FACTOR_ALG_H__
