#include "abstract_root_finder.h"

#include <typeinfo>
#include "log.h"

ARootFinder::ARootFinder()
{
}

ARootFinder::~ARootFinder()
{
}

int ARootFinder::SetFactors(unsigned long int aNumFactors, Polynomial **aFactors)
{
	// just set some of inner pointers
	this->iNumFactors = aNumFactors;

	if (aFactors != NULL)
	{
		this->iFactors = aFactors;
		return 0;
	}
	else
	{
		CLog::LogError(WHEREARG,(char *)typeid(this).name(),
				"NULL pointer given.",-1,-1,
				"NULL pointer given to SetFactors().");
		return -1;
	}
}

int ARootFinder::SetNumberField(Polynomial *aPolynomial)
{
	if (NULL == aPolynomial)
	{
		CLog::LogError(WHEREARG,(char *)typeid(this).name(),
				"NULL pointer given.",-1,-1,
				"NULL pointer given to SetNumberField().");
		return -1;
	}
	if (aPolynomial->GetDegree() <= 1)
	{
		CLog::LogError(WHEREARG,(char *)typeid(this).name(),
				"Strange polynomial given",-1,-1,
				"Strange polynomial given to SetNumberField().");
		return -1;
	}

	this->iNumFieldPolynomial = aPolynomial;
	
	return ConstRC::Ok;
}

