#ifndef __ABSTRACT_ROOT_FINDER_H__
#define __ABSTRACT_ROOT_FINDER_H__

#include "polynom_class.h"

/*!
\brief Common ancestor for SquareRoot finding in integral domain of number field.
*/
class ARootFinder {
	public:
		ARootFinder();
		~ARootFinder();

		/// Sets pointer to square given as product of elements
		int SetFactors(unsigned long int aNumFactors, Polynomial **aFactors);
		
		/// Sets number field via its minimal polynomial
		int SetNumberField(Polynomial *aPolynomial);
		
	protected:
		/// Number of elements of product
		unsigned long int iNumFactors;
		/// Pointer to elements of product
		Polynomial **iFactors;
		/// Number field minimal polynomial
		Polynomial *iNumFieldPolynomial;
	
};

#endif // __ABSTRACT_ROOT_FINDER_H__