#ifndef __CANDIDATE_CLASS_H__
#define __CANDIDATE_CLASS_H__

#include "polynom_class.h"
#include "xml_helper.h"

/*!
\brief  An enveloping class for candidate polynomials
*/
class CandidateClass : public virtual MSerializable
{
protected:
	long allocated;		///<The number of allocated entries

public:
	Polynomial **Poly;	///<The candidate polynomials
	mpz_t *Root;		///<The roots of the candidate polynomials
	mpf_t *Skewness;	///<The skewnesses of the candidate polynomials
	mpf_t *Alpha;		///<The alphas of the candidate polynomials
	mpf_t *Rating;		///<The ratings of the candidate polynomials

protected:
	int Allocate();
	int Deallocate();

public:
	CandidateClass(long aAllocation);
	virtual ~CandidateClass();

	// De/Serialization methods
	int Serialize(const CBaseParameters& aParam) const;
	int Serialize(const CBaseParameters& aParam, xmlTextWriterPtr& aWriter) const;

	int Deserialize(const CBaseParameters& aParam);
	int Deserialize(const CBaseParameters& aParam, xmlTextReaderPtr& aReader);

};

#endif // __CANDIDATE_CLASS_H__
