#ifndef __CC_TABLE_H__
#define __CC_TABLE_H__

#include "structures.h"

/*!
 * \brief Table for cycle construction - relation processing phase.
 *
 * This table is used for creating smooth relations from partial relations. Up to one largish primeideal can be used in partial relations.
*/
class CCCTable
{
public:
	///Table itself
	cycle_construction_entry *	Table;
	///Number of the allocated table entries
	long			AllocatedSize;
	/*
		Count of elements in table.
 	*/
	long			Count;

	CCCTable();
	~CCCTable();

	void DeleteTable();
	void ClearTable();
	int SetupTable(long aAmount);

	int PutToConstructionEntry(cycle_construction_entry * aEntry, int aRelationIndex);
	int RemoveDuplicitePaths();

	int PrintCycleSizes();


private:

	CCCTable(const CCCTable& aOperand) {}
};


#endif // __CC_TABLE_H__
