#ifndef __CONST_DEBUG_H__
#define __CONST_DEBUG_H__

// !!! important !!! do not forget to turn on log (log.h)

//  ---------------------  CMontgomeryPolySelPhase  ---------------------

//#define DEBUG_POLY_SEL_PHASE_GENERATE_POLY // debug info for method Generate
//#define DEBUG_POLY_SEL_PHASE_WRITE_ALPHA	// write too big alpha of good polynomials
//#define DEBUG_POLY_SEL_PHASE_WRITE_ROOTS   // write roots of the candidate pairs in method Generate 


//  ---------------------  CKleinjungPolySelPhase  ---------------------

//#define DEBUG_POLY_SEL_PHASE_KLEINJUNG_DEBUG_ON   // turn on debug info for Kleinjung algorithm
//#define DEBUG_INFO_APolyPhase	// debug info for abstract poly class


//  ---------------------  CPolySelectionPhase  ---------------------

///AssertionMode is turn on - so it is check if iAssertionMode = true
//#define DEBUG_POLY_SEL_PHASE_ASSERTION_MODE_ON
#define DEBUG_POLY_SEL_PHASE_INFO_STATS_ON   // saving statistics
#define DEBUG_POLY_SEL_PHASE_TIME_MESSAGE_ON // saving times info


//  ---------------------  CRelProcessingPhase  ---------------------

///AssertionMode is turn on - so it is check if iAssertionMode = true
//#define DEBUG_REL_PRO_PHASE_ASSERTION_MODE_ON
///If we have to save quadratic characters - they could be used in the square root phase 
//#define DEBUG_REL_PRO_PHASE_SAVE_QUAD_CHARACTERS
///If we should print the FBs to the screen
//#define DEBUG_REL_PRO_PHASE_PRINT_FB


//  ---------------------  CNFSClassicalSievingPhase  ---------------------
//  ---------------------  CLatticeSievingPhase  ---------------------

#define DEBUG_SIEVING_PHASE_INFO_STATS_ON // saving statistics
#define DEBUG_SIEVING_PHASE_TIME_MESSAGE_ON // saving times info
#define DEBUG_SIEVING_PHASE_TECHNICAL_TIMES_ON // saving times info, more details
//#define DEBUG_SIEVING_PHASE_INFO_STATS_DIVREM_ON // saving ESSDivrem info
//#define DEBUG_SIEVING_PHASE_ASSERTION_MODE_ON // AssertionMode is turn on - so it is check if iAssertionMode = true

//#define DEBUG_SIEVING_PHASE_SERIALIZATION_OFF // turn off serialization 

//#define DEBUG_SIEVING_PHASE_WRITE_DUMP_FILE // writing aux dump file - sieving and FBs
//#define DEBUG_SIEVING_PHASE_CACHE_FLUSHER // for debug FlushUpdateCache method
//#define DEBUG_SIEVING_PHASE_ONE_PRIME  // for critical prime debug
//#define DEBUG_SIEVING_PHASE_BLOCK_SIEVE // for debugging SieveWithLargishPrimes
//#define DEBUG_SIEVING_PHASE_UPDATE_NFS_ROOT // for debugging UpdateNfsRoot
//#define DEBUG_SIEVING_PHASE_NFS_ALGEBRAIC_TEST // for test - more info
//#define DEBUG_SIEVING_PHASE_NFS_INTEGRAL_TEST // for test - more info
//#define DEBUG_SIEVING_PHASE_COMPUTE_EXP_ALG_LOG // expected alg log value is computed for each block

//#define DEBUG_SIEVING_PHASE_ADV_FB_CONTROL // control if values for lattice are correct

#define DEBUG_SIEVING_PHASE_WRITE_LC_DIVIDING_PRIMES // write all primes which divide leading coeff of their polynomial

#define DEBUG_SIEVING_PHASE_CRITICAL_PRIME 0
#define DEBUG_SIEVING_PHASE_CRITICAL_ROOT 0

//  ---------------------  CSquareRootPhase  ---------------------

#define DEBUG_SQUARE_ROOT_PHASE_INFO_STATS_ON // saving statistics
#define DEBUG_SQUARE_ROOT_PHASE_TIME_MESSAGE_ON // saving times info
///algebraic representation will be computed - very slow!!!
//#define DEBUG_SQUARE_ROOT_PHASE_ALG_REPRESENTATION_ON
///info about combining relations - useful only with above
//#define DEBUG_SQUARE_ROOT_PHASE_COMBINE_INFO_ON
///control result algebraic representation with quadratic characters - very slow!!!
//#define DEBUG_SQUARE_ROOT_PHASE_CONTROL_WITH_CHARACTERS_ON

//  ---------------------  Relations  ---------------------

//#define DEBUG_RELATION_DETERMINE_TYPE
//#define DEBUG_RELATION_MIN_PARTIAL_FACTOR 40000
//#define DEBUG_RELATION_CONTROL_ACCESS

//  ---------------------  CRelationPart  ---------------------

//#define DEBUG_RELATION_PART_COMBINE_NORMS // when combine two relations then we multiply also the norms


//  ---------------------  Hashtables  ---------------------

//  ---------------------  CFrequencyHashtable  ---------------------

///print all information about count of prime ideals, count of high frequency prime ideals and number of relation singletons
//#define DEBUG_FREQUENCY_HASHTABLE_PRINT_STATS 
///turn on info mode for frequency hashtable
#define DEBUG_FREQUENCY_HASHTABLE_INFO_MODE_ON

//  ---------------------  GENERAL  ---------------------

///For number substitution - this value shouldn't be tested
#define DEBUG_NO_TEST -1

#define DEBUG_PREFETCHING_ON

/// If we just measure some statistics - turn off waiting in program.cpp at the end of program
//#define MEASUREMENT_ON


#endif // __CONST_DEBUG_H__
