#ifndef __CONST_FILTERING_PHASE_H_
#define __CONST_FILTERING_PHASE_H_

#include "const_sieving_phase.h"
#include "const_rel_processing_phase.h"

/*!
 * \brief Class of constants used in filtering phase
*/
class ConstFPhase
{
public:
	static const int INNER_STATE_COUNT = 10;
	static const bool AUTO_SERIALIZABLE = false;

	static const unsigned int FREQUENCY_TWO = 2;
	static const unsigned int MAX_FREQUENCY_WEIGHT = 33554432; // 2^25
	static const int	UNDEFINE_COMPONENT = -1;
	static const int	NEW_COMPONENT = -2;

	static const int QUAD_CHARS_COUNT;

	static const variations_types VARIATIONS_TYPE;
	static const species_of_matrices RELATION_MATRIX_TYPE;

	///how much relations over ideals should be kept for merge and then for linear phase - default = 0.05
	static const double KEEP_RELATION_PERCENTAGE;

};

#endif // __CONST_FILTERING_PHASE_H_
