#ifndef __CONST_LINEAR_PHASE_H_
#define __CONST_LINEAR_PHASE_H_

#include "const_rel_processing_phase.h"
#include "enums_common.h"

/*!
 * \brief Class of constants for linear phases
*/
class ConstLPhase
{
public:
	static const bool AUTO_SERIALIZABLE;
	static const bool RANK_CALC_MODE;
	static const bool DENSITY_MODE;
	static const bool TIME_MESSAGE_MODE;
	static const bool CHECK_FINAL_RESULT;
	static const int  INNER_STATE_COUNT;

	static const matrix_solver_type  MATRIX_SOLVER_TYPE;
	static const species_of_matrices RELATION_MATRIX_TYPE;
	static const species_of_matrices LANCZOS_AUX_MATRIX_TYPE;

	static const std::string MATRIX_RESULT_FILENAME;
	static const std::string RELATION_MATRIX_FILENAME;

};

#endif // __CONST_LINEAR_PHASE_H_
