#include "const_poly_selection_phase.h"

const bool	ConstPSPhase::AUTO_SERIALIZABLE					= false;
const int	ConstPSPhase::INNER_STATE_COUNT					= 6;
const int	ConstPSPhase::INFO_STAT_COUNT					= 3;
const int	ConstPSPhase::INFO_TIME_COUNT					= 4;
const int	ConstPSPhase::HALF_CIRCLE_SUBINTERVALS_COUNT	= 1000;
const int	ConstPSPhase::MPF_T_PRECISION					= 30;
const int	ConstPSPhase::MPF_T_HIGH_PRECISION				= 256;
const long	ConstPSPhase::CANDIDATES_COUNT					= 100;
const int	ConstPSPhase::ALPHA_PRIME_BOUND					= 100;
const int	ConstPSPhase::ALPHA_SMALLER_PRIME_BOUND			= 2000;
const int	ConstPSPhase::CONTENT_TRIES						= 3000;
const long	ConstPSPhase::CONTENT_BOUND						= 2000000;
const int	ConstPSPhase::CHI_INVERSE						= -50;
const int	ConstPSPhase::CHI_MIN_LOG						= -13; // 2^{-13} ~ 1/10000
const int	ConstPSPhase::CHI_MAX_LOG						= -10; // 2^{-10}  ~ 1/1000
const long	ConstPSPhase::MAX_CANDIDATES_PER_LC				= 40;
const int	ConstPSPhase::MIN_AD_PER_C						= 30; // how many a_{d} we want to find for one c
const int	ConstPSPhase::C_BASE							= 12; // 4 * 3 ///2520; // 8 * 9 * 5 * 7
const int	ConstPSPhase::RHO_EXPANSION_LENGTH				= 30;
const int	ConstPSPhase::MAXIMAL_RHO_VALUE					= 10;
const int	ConstPSPhase::PRIME_NUMBERS_DIVIDING_LEADING	= 64;
const int	ConstPSPhase::STEEPEST_DESCENT_LEVEL			= 10;
const int	ConstPSPhase::SKEWNESS							= 500;
//const int	ConstPSPhase::J0								= 1000;
const int	ConstPSPhase::J1								= 10;
//const int	ConstPSPhase::MAX_J_PRIME						= 130;
//const int	ConstPSPhase::SMALL_PRIME_COUNT					= 96;
//const int	ConstPSPhase::C_PRIME_COUNT						= 56;
const int	ConstPSPhase::MIN_POLY_DEGREE					= 3;
const int	ConstPSPhase::POLY_DEGREE_STEP					= 80; // in binary system
const int	ConstPSPhase::SELF_INITIALIZING_DELAY			= 0;
const int	ConstPSPhase::MONIC_SEARCH_2_MULTIPLY_COUNT		= 7;
const int	ConstPSPhase::C_CHANGE_COUNT					= 10;
const int	ConstPSPhase::M_CHANGE_COUNT					= 10000;

const int	ConstPSPhase::QUADRATIC_POLY_DEGREE				= 2;
const int	ConstPSPhase::PRIME_CHANGE_COUNT				= 10000;
const int	ConstPSPhase::MONTGOMERY_CHI_INVERSE			= 50;

const poly_gen	ConstPSPhase::POLY_GEN_TYPE					= EGenerateNonmonicPolynomial;

const double ConstPSPhase::ALPHA_BOUND								= -1.5;
const double ConstPSPhase::ALPHA_ABORT								= 0.4;
const double ConstPSPhase::ALPHA_STEP								= 0.05;
const double ConstPSPhase::ALPHA_STEP_BACK							= 0.025;
const double ConstPSPhase::INITIAL_STEEPEST_DESCENT_STEP			= 32.0;
const double ConstPSPhase::SKEWED_LEADING_COEFFICIENT_LOW_BOUND		= 0.4;
const double ConstPSPhase::SKEWED_LEADING_COEFFICIENT_HIGH_BOUND	= 0.9;
const double ConstPSPhase::THIRD_COEFFICIENT_RELATIVE_LENGTH		= 0.78;
const double ConstPSPhase::IFS_BOUND								= 0.382;
const double ConstPSPhase::IFS_IMPROVEMENT							= 5.0;

const double ConstPSPhase::MONTGOMERY_ALPHA_BOUND					= -0.10;
const double ConstPSPhase::MONTGOMERY_ALPHA_ABORT					= 0.75;

