#ifndef __CONST_REL_PROCESSING_PHASE_H_
#define __CONST_REL_PROCESSING_PHASE_H_

#include "const_sieving_phase.h"

/*!
 * \brief Class of constants for relation processing phases
*/
class ConstRPPhase
{
public:

	static const int INNER_STATE_COUNT;
	static const bool AUTO_SERIALIZABLE;
	static const int ROOTS_LIST;
	static const int QUAD_CHARS_COUNT;

	/// Max size of used memory for relation hashtable
	static const int MERGE_MEMORY_SIZE = 1024; // in Kbits == 1GB
	/// Maximal possible merge
	static const int MERGE_MAX_MERGE_FREQUENCY = 4;
	/// If we should use Hamming distance as a weight or number of original relations - for determination of set for merge
	static const bool MERGE_USE_RELATION_HAMMING_WEIGHT = true;
	/// Starting merge frequency - 3 is the first meaningful value
	static const int MERGE_STARTING_FREQUENCY = 3;

	static const int MEGABIT = 1048576; // 1024*1024

	static const variations_types VARIATIONS_TYPE;
	static const species_of_matrices RELATION_MATRIX_TYPE;

	static const std::string RELATION_MATRIX_FILENAME;
	static const std::string QUAD_CHARS_FILENAME;
	static const std::string RELATIONS_RESULT_FILENAME;

};

#endif // __CONST_REL_PROCESSING_PHASE_H_
