#include "const_sieving_phase.h"
#include "enums_common.h"

const bool ConstSPhase::AUTO_SERIALIZABLE				= false;
const bool ConstSPhase::CHECK_ALL_MODE					= false;
const int ConstSPhase::INNER_STATE_COUNT				= 7;
const int ConstSPhase::INFO_TIME_COUNT					= 13;
const int ConstSPhase::INFO_STAT_COUNT					= 20;
const int ConstSPhase::INTEGRAL_ERROR_FACTOR			= 3; // for prime below 128
const int ConstSPhase::ALGEBRAIC_ERROR_FACTOR			= 4; // expected value is 4-5
const int ConstSPhase::EXCEPTED_ALGEBRAIC_LOG_STEP		= 5;
const int ConstSPhase::QUAD_CHARS_COUNT					= 64;
const int ConstSPhase::RELATION_RESERVE					= 10;
const int ConstSPhase::UNLIMITED_ITERATIONS				= -1;
const int ConstSPhase::INTERMEDIATE_ROOTS_COUNT			= 200;
const int ConstSPhase::MAX_INDEPENDENT_CYCLES_COUNT		= 1000000000;
const int ConstSPhase::MIN_PRIME_TO_SIEVE_WITH			= 128;
const int ConstSPhase::PARTIAL_FACTOR_MULTIPLIER		= 128;
const int ConstSPhase::RELATION_BUFFER_RESERVE			= 256;
const int ConstSPhase::MAX_LINE_SIEVE_HALFLINE			= 1000000000;
const int ConstSPhase::MAX_FACTOR_BASE_UPPER_BOUND		= 1000000000;
const int ConstSPhase::TIME_MESSAGE_INTERVAL			= 0;
const int ConstSPhase::MAX_ITERATIONS					= UNLIMITED_ITERATIONS;
const int ConstSPhase::MAX_RELATION_BUFFER_SIZE			= 512;
const int ConstSPhase::THRESHOLD_OPTIMIZER_POLICY		= 3;
const int ConstSPhase::THRESHOLD_OPTIMIZER_INT			= 4;
const int ConstSPhase::LOGARITHM_BASE					= 4;

const double ConstSPhase::POLY_SKEWNESS					= 1.0;
const double ConstSPhase::PROPAB_PRIMES_SUM_RATIO		= 0.95;

const unsigned int ConstSPhase::ELEMENT_MASK[ConstSPhase::ELEMENT_MASK_COUNT] = {0x00000000, 0x80000000};	

const variations_types ConstSPhase::VARIATIONS_TYPE			= EDoNotUseVariations;
const line_sieve_size ConstSPhase::LINE_SIEVE_SIZE			= ESize64k;
const nfs_sieving_direction ConstSPhase::SIEVING_DIRECTION	= EIncrementB;
const supporting_factor_alg_types ConstSPhase::SUPPORTING_FACTOR_ALG = EFAPollardRho;

