#ifndef __DIVISORS_H__
#define __DIVISORS_H__

#include "mserializable.h"
#include "structures.h"

/*!
 * \brief  Divisor management
 */
class CDivisors : public virtual MSerializable
{
private:
// CONSTANTS
	///Value of which we extend field of divisors if needed
	static const int DEFAULT_ELEMENTS_ADD = 20;

public:
	signed long MaxElementIndex;
	unsigned long AssignedElements;
	nfs_sieving_element* Elements;

public:

	CDivisors(int aAssignedElements = 0);
	CDivisors(const CDivisors& aOperand);
	~CDivisors();

	int AddDivisor(nfs_sieving_element * aElement, bool aAssertionMode = false);
	int AddDivisor(main_sieving_type aDivisor, unsigned int aExponent, main_sieving_type aRoot, int aFlags, int& aLastIndex, bool aAssertionMode = false);
	int CombineWithDivisors(const CDivisors &aOperand);
	int Copy2(CDivisors& aOperand);
	int ControlExponents();
	bool Equals(const CDivisors& aOperand) const;

	void PrintToScreen();
	int PrintToFile(FILE* aFw);
	int ReadFromFile(long aCount, std::string aLine);
	int ReadFromFile(long aCount, main_sieving_type aLargeBound, std::string aLine);

	int Set_AssignedElements(unsigned long aAssignedElements);

	// De/Serialization methods
	int Serialize(const CBaseParameters& aParam, xmlTextWriterPtr& aWriter) const;

	int Deserialize(const CBaseParameters& aParam, xmlTextReaderPtr& aReader);

};


#endif // __DIVISORS_H__
