#ifndef __DUPLICATE_HASHTABLE_H__
#define __DUPLICATE_HASHTABLE_H__

#include "structures.h"

/*!
 * \brief Hashtable for removing duplicates in filtering phase
 */
class CDuplicateHashtable
{
private:
// CONSTANTS
	///Number PI * 10^17 
	static const relation_hash_type PI	= 314159265358979323;
	///Number E * 10^17 
	static const relation_hash_type E	= 271828182845904523;


public:
	///Internal hashtable for largish prime ideals.
	relation_hash_type *	Hashtable;
	///Number of the allocated hashtable entries
	relation_index_type	AllocatedSize;
	///Hash mask - hash is large prime AND with mask 
	relation_index_type	Mask;

public:

	CDuplicateHashtable();
	~CDuplicateHashtable();

	void DeleteHashtable();
	int ClearHashtable();
	int SetupHashtable(relation_index_type aAmount);

	int AddToTable(main_sieving_type aA, main_sieving_type aB, bool & aPresent);
	int FindPrimeInHashtable(relation_hash_type aRelationHash, bool & aPresent, relation_index_type & aIndex) const;

private:

	CDuplicateHashtable(const CDuplicateHashtable& aOperand) {}

	int CollisionResolution(relation_index_type aHash, relation_hash_type aRelationHash, relation_index_type & aIndex) const;

};

#endif // __DUPLICATE_HASHTABLE_H__
