#ifndef __FILTERING_RELATION_PART_H__
#define __FILTERING_RELATION_PART_H__

#include "relation_part.h"

/*!
 * \brief Relation part for filtering phase
 */
class CFRelationPart : public virtual MSerializable
{
private:
	std::string iAuxStr;
	main_sieving_type iLargePrimeBound;

public:
	///Divisors of a norm of this relation part
	CDivisors	Main;

	///Polynomial representation in an integral domain - c_{d}a + b\bar{theta}
	Polynomial* Poly;
	///Index in the CDivisors.Elements where large primes started
	int			LargePrimeIndex;

public:

	CFRelationPart();
	CFRelationPart(const CFRelationPart& aOperand);
	~CFRelationPart();

	int CombineWithPart(const CFRelationPart &aOperand, Polynomial * aThetaPoly);
	int CombineWithPart(const CFRelationPart &aOperand);
	int Copy2(CFRelationPart& aOperand);
	int Copy2(CRelationPart& aOperand);
	int CopyFrom(CRelationPart& aOperand);

	int Reset();
	bool Equals(const CFRelationPart& aOperand) const;

	void PrintToScreen();
	int PrintToFile(FILE* aFw);
	int ReadFromFile(FILE * aFr, char * aBuffer, int aBufferSize);

	// De/Serialization methods
	int Serialize(const CBaseParameters& aParam, xmlTextWriterPtr& aWriter) const;

	int Deserialize(const CBaseParameters& aParam, xmlTextReaderPtr& aReader);

public:
	// Getters and Setters
	main_sieving_type Get_LargePrimeBound() const { return this->iLargePrimeBound; }
	void Set_LargePrimeBound(main_sieving_type aLargePrimeBound);

};


#endif // __FILTERING_RELATION_PART_H__
