#ifndef __LINEAR_PHASE_H__
#define __LINEAR_PHASE_H__

#include "abstract_linear_phase.h"


///General linear phase. Can be use for NFS and QS
class CLinearPhase : public ALinearPhase
{
protected:

	/*!
		Fill the iPhaseFunctors with correct function pointers.
		This method is called from InitParameters in APhase.
	*/
	int FillFunctorField();

	///Reset all resources which was used and prepare for new start. Also set inner state.
	int Reset();

	/// Solve linear system
	int SolveSystem(); 

	///Save phase's result
	int SaveResult();

	///Init all parameters necessary for calculation - get from iParameters
	int InitParameters();


public:

	CLinearPhase();
	~CLinearPhase();

	///Delete all used files according to enum cleaning_types
	int CleanUp(AFactorAlgParameters* aParameters, int aPhaseNBR, cleaning_types aType, bool aError);
	
	///Start method for linear phase
	int RunPhase(AFactorAlgParameters*  aParameters);

	// De/Serialization methods
	int Serialize(const CBaseParameters& aParam) const;
	int Serialize(const CBaseParameters& aParam, xmlTextWriterPtr& aWriter) const;

	int Deserialize(const CBaseParameters& aParam);
	int Deserialize(const CBaseParameters& aParam, xmlTextReaderPtr& aReader);

};

#endif // __LINEAR_PHASE_H__