#include "lp_hashtable_type2.h"

#include "const_return_codes.h"
#include "const_element_flags.h"
#include "const_debug.h"
#include "const_rel_processing_phase.h"
#include "const_hashtables.h"
#include "nfs_utils.h"
#include "log.h"

//CLPType2Hashtable::CLPType2Hashtable()
//{
//	this->Hashtable = NULL;
//	this->Count = 0;
//	this->AllocatedSize = 0;
//	this->Mask = 0;
//}
//CLPType2Hashtable::~CLPType2Hashtable()
//{
//	DeleteHashtable();
//}
//void CLPType2Hashtable::DeleteHashtable()
//{
//	if (this->Hashtable != NULL)
//	{
//		free(this->Hashtable);
//		this->Hashtable = NULL;
//		this->AllocatedSize = 0;
//		this->Count = 0;
//		this->Mask = 0;
//	}
//}
//int CLPType2Hashtable::SetupHashtable(long aAmount)
//{
//	if (this->Hashtable != NULL)
//	{
//		CLog::LogError(WHEREARG,"CLPType2Hashtable","SetupHashtable",0,0,"Hashtable is not NULL.");
//		return ConstRC::BadArgument;
//	}
//
//	this->AllocatedSize = Utils::GetSuitableHashtableSize(aAmount);
//	this->Hashtable = (nfs_hashtable_entry_type_2*) NFSUtils::AllocationMachine((void**) &this->Hashtable, this->AllocatedSize * sizeof(nfs_hashtable_entry_type_2));
//	if (this->Hashtable == NULL)
//	{
//		CLog::LogError(WHEREARG,"CLPType2Hashtable","SetupHashtable", 0, this->AllocatedSize * sizeof(nfs_hashtable_entry_type_2),"Could not allocate space for the hashtable");
//		return ConstRC::NotEnoughMemory;
//	}
//	this->Mask = this->AllocatedSize - 1;
//	ClearHashtable();
//
//	return ConstRC::Ok;
//}
//int CLPType2Hashtable::ClearHashtable()
//{
//	if (this->Hashtable == NULL)
//	{
//		CLog::LogError(WHEREARG,"CLPType2Hashtable","ClearHashtable",0,0,"Hashtable is NULL.");
//		return ConstRC::BadArgument;
//	}
//
//	memset(Hashtable, 0, AllocatedSize*sizeof(nfs_hashtable_entry_type_2));
//
//	// Special case of i = 0: PRIME = 1, root of its own component.
//	this->Hashtable->value = 1;
//	this->Hashtable->root_fingerprint = 0;
//	this->Hashtable->ancestor = 0;
//
//        for(nfs_hashtable_entry_type_2 *index = this->Hashtable+1; index < this->Hashtable+AllocatedSize-1; index ++)
//        {
//                index->value=ConstHT::FULL_MASK_NFS;
// 
//        };
//
//	this->Count = 1;
//
//	return ConstRC::Ok;
//}
///*!
//	This method tries to find large prime aPrime in hashtable, and indicates
//	the result of this search in two values: the return value, which is an index
//	corresponding to the real or expected position of the prime in the hashtable,
//	and value of aPresent, which indicates whether the prime has already been
//	in the hashtable or no. In the second case, the return value has meaning
//	"if you want to insert aPrime, this index is the one where it should be inserted".
//
//*/
//int CLPType2Hashtable::FindPrimeInHashtable(large_prime_type aPrime, large_prime_type aRootFingerprint, bool & aPresent, long & aIndex) const
//{
//	if (this->Hashtable == NULL)
//	{
//		CLog::LogError(WHEREARG,"CLPType2Hashtable","FindPrimeInHashtable",0,0,"Hashtable is NULL.");
//		aPresent = false;
//		aIndex = 0;
//		return ConstRC::BadArgument;
//	}
//
//	long hash = (aPrime >> 1) & this->Mask;			
//	if (CollisionResolution(hash, aPrime, aRootFingerprint, aIndex) != ConstRC::Ok)
//	{
//		aPresent = false;
//		aIndex = 0;
//		return ConstRC::GeneralError;
//	}
//
//    if (this->Hashtable[aIndex].value == ConstHT::FULL_MASK_NFS) 
//	{
//		aPresent = false;
//	} 
//	else 
//	{
//		aPresent = true;
//	}
//
//	return ConstRC::Ok;
//}
///*!
//	
//	A collision resolution algorithm for insertion into hashtable. Returns in aIndex
//	the index of first suitable free position, where aPrime can be stored.
//
//*/
//int CLPType2Hashtable::CollisionResolution(long aHash, large_prime_type aPrime, large_prime_type aRootFingerprint, long & aIndex) const
//{
//	aIndex = aHash;
//	long iter = 0;
//
//	if (this->Hashtable == NULL)
//	{
//		CLog::LogError(WHEREARG,"CLPType2Hashtable","CollisionResolution",0,0,"Hashtable is NULL.");
//		return ConstRC::BadArgument;
//	}
//
//	nfs_hashtable_entry_type_2 * aux = this->Hashtable + aIndex;
//	nfs_hashtable_entry_type_2 * end = this->Hashtable + this->AllocatedSize;
//
//    while (((aux->value != aPrime) || (aux->root_fingerprint != aRootFingerprint)) && (aux->value != ConstHT::FULL_MASK_NFS)) 
//	{
//		iter++;
//		aux++;
//		// Should we go over the bounds of the table, we must reset aux to start.
//		if (aux >= end) 
//		{
//			if (iter > this->AllocatedSize) 
//			{
//				// this shouldn't happend so we use just stupid control
//				CLog::LogError(WHEREARG,"CLPType2Hashtable","CollisionResolution",0,0,"The hash table has overflown.");
//				return ConstRC::GeneralError;
//			}
//			aux = this->Hashtable;
//		}
//	}
//
//	aIndex = aux - this->Hashtable;
//
//	return ConstRC::Ok;
//}
//int CLPType2Hashtable::AddToTable(large_prime_type aPrime, large_prime_type aRootMask, unsigned long aAncestor, unsigned long aRelation, unsigned long aIndex)
//{
//	if (this->Hashtable == NULL)
//	{
//		CLog::LogError(WHEREARG,"CLPType2Hashtable","CollisionResolution",0,0,"Hashtable is NULL.");
//		return ConstRC::BadArgument;
//	}
//
//	nfs_hashtable_entry_type_2 * aux = this->Hashtable + aIndex;
//	aux->value = aPrime;
//	aux->root_fingerprint = aRootMask;
//	aux->ancestor = aAncestor;
//	aux->relation = aRelation;
//
//	return ConstRC::Ok;
//}
