#ifndef __MINIMUM_SPANNING_TREE_H__
#define __MINIMUM_SPANNING_TREE_H__

#include "integer_matrix_class.h"
#include "structures.h"

/*!
 * \brief	Algorithm for solving Minimum spanning tree problem.  
 * We are using Prim's algorithm.  This implementation is suitable only for
 * small graphs.  - Time complexity O(V^2) - but this implementation is quite
 * simple so could be fast
*/
class CMinimumSpanningTreeAlg
{
private:

	int iVerticesCount;
	int iAllocatedSize;
	bool * iUsedVertices;

	int iCurrentUsed;
	int iCurrentRest;
	int i,j;
	int iProcessedUsed;
	int iProcessedRest;
	int iValue;
	graph_edge_t	iMinEdge;
	int				iMinWeight;


public:
	CMinimumSpanningTreeAlg();
	~CMinimumSpanningTreeAlg();

	void DeleteAlg();
	void ClearAlg();
	int SetupAlg(int aVerticesCount);

	int PrimAlgorithm(IntegerMatrix * aAdjacencyMatrix, int aVerticesCount, graph_edge_t * aTree);
	int PrimAlgorithm2(graph_wedge_t * aEdges, int aEdgedCount, int aVerticesCount, graph_edge_t * aTree);

private:
	CMinimumSpanningTreeAlg(const CMinimumSpanningTreeAlg& aOperand) {}

};

#endif // __MINIMUM_SPANNING_TREE_H__
