#ifndef __MURPHY_POLY_SELECTION_PHASE_H__
#define __MURPHY_POLY_SELECTION_PHASE_H__

#include "abstract_poly_selection_phase.h"
#include "candidate_pairs.h"
#include "const_poly_selection_phase.h"


///Murphy's polynomial selection phase for NFS. Type ?????
class CMurphyPolySelPhase : public APolyPhase
{
/*MONTGOMERY	
protected:

	///We have two polynomials so we need two factor bases bounds
	long		iFBBound[ConstPSPhase::GENERATED_POLYS_COUNT];
	///The inverse value of chi (multiplied by 10)
	int			iChiInverse;

	mpz_t iSievingIntervalLength;
	CCandidatePairs * iCandidatePolyPairs;

	mpz_t		iRunningPrime;
	long		iRound;
	long		iFoundCandidatePolyCount;
	long		iRatedCandidatePolyCount;
	Polynomial *	iResultFirstPoly;
	Polynomial *	iResultSecondPoly;

	long		iRSerialFoundCandPolyCount;
	long		iRSerialRatedCandPolyCount;
	long		iRSerialRound;
	mpz_t		iRSerialRunningPrime;

	long		iRSerialRunPrimeChangeCount;
	long		iRSerialRunPolyCount;

	std::string iCandPolyPairsFullFileName;
	std::string iRunningSerialFullFileName;

protected:
*/	
	/*!
		Gauss base reduction (like LLL for 2-dim lattice) 
		more Cohen - A Course in Computational Algebraic Number Theory - algorithm 1.3.14
	*/
/*MONTGOMERY	
	int GaussReduction(Polynomial *& a, Polynomial *& b);

	int Generate(bool aAdvanced, bool aEnforceRealRoots);
	int Rating(mpf_t aRating, mpf_t aAlpha, long * aRoots, Polynomial *aPoly1, Polynomial *aPoly2, mpf_t aLogBase1, mpf_t aLogBase2);
*/
	// Phase methods

	/*!
		Fill the iPhaseFunctors with correct function pointers.
		This method is called from InitParameters in APhase.
	*/

	int FillFunctorField();

	///Dispose all resources which was used and prepare for new start. Also set inner state.
/*MONTGOMERY
	int Reset();
	int DisposeGMP();
	int DisposeMutexes();

	int InitParameters();
	int GenerateCandidates();
	int ChooseBest();
*/	int SaveResult();

	// Printing methods
/*	void PrintHeader();
	void PrintValues();
	void PrintEffectiveness();

	// For running serialization
	int PrepareRunningSerialization();
*/
public:

	CMurphyPolySelPhase();
	~CMurphyPolySelPhase();

	
	///Delete all used files according to enum cleaning_types
	int CleanUp(AFactorAlgParameters* aParameters, int aPhaseNBR, cleaning_types aType, bool aError);

	int Serialize(const CBaseParameters& aParam, xmlTextWriterPtr& aWriter) const;
	int Serialize(const CBaseParameters& aParam) const;

	int Deserialize(const CBaseParameters& aParam, xmlTextReaderPtr& aReader);
	int Deserialize(const CBaseParameters& aParam);


};

#endif // __MURPHY_POLY_SELECTION_PHASE_H__