#ifndef __NEWTON_ROOT_FINDER_H__
#define __NEWTON_ROOT_FINDER_H__

#include "abstract_root_finder.h"

/*!
 * \brief Compute square root using Newton iteration..
 *
 *   
 */

class CNewtonRootFinder : public ARootFinder 
{
	public:
		/// Returns Square Root as polynomial 
		int FindRoot(Polynomial *aResult);
	 	/// Multiplies Factors and derivate of number field minimal polynomial
		int MultipleFactors(Polynomial *aResult);
		/// The algorithm of Shanks and Tonelli for Galois field
		int Shanks_Tonelli_GF(Polynomial *Result, Polynomial *aSquare, mpz_t aPrime);
		/// Modular Newton iteration for square root 
		int SquareRootNewtonIter(Polynomial *aResult, Polynomial *aSquareRoot, 
				Polynomial * aSquare, mpz_t aPrime, unsigned int aModulPower,
				bool aSwapAllowed, bool aTestSquare,bool aTestSquareMod);
		/// Compute upper bound for coefficients of square root given as polynomial
		int ComputeBoundLog(mpz_t aResult, mpz_t aBase);
};

#endif // __NEWTON_ROOT_FINDER_H__