#ifndef __NFS_PARAMETERS_H__
#define __NFS_PARAMETERS_H__

#include "abstract_factor_alg_parameters.h"
# include "job_parameters.h"

/*!
 * \brief Parameter processing fo the number field sieve
 */
class CNFSParameters : public AFactorAlgParameters, public JobParameters
{
protected:
	size_t FindInputParamSeparator(string aStr, size_t aPos);
	string UnescapeInputParameter(string aStr);
	int ParseInputParameter(const char* aParam);

public:

	CNFSParameters();
	CNFSParameters(const CNFSParameters& aOperand);
	~CNFSParameters();

	int ParseInputParameters(int argc, char *argv[]);

	// De/Serialization methods
	int Serialize(const CBaseParameters& aParam, xmlTextWriterPtr& aWriter) const;

	int Deserialize(const CBaseParameters& aParam, xmlTextReaderPtr& aReader);

	// methods of JobParameters
        const string GetStringParameter(const char* aName) const;
        int GetIntegerParameter(const char* aName) const;
        double GetDoubleParameter(const char* aName) const;
        bool GetBoolParameter(const char* aName) const;
        int GetMpzParameter(const char *aName, mpz_t aResult) const;
        bool Complete() const;
        string GetFailureReason() const;
        JobParameters *CreateCopy() const;
	void Print() const;
	void PrintInBatch(const char *aPrefix) const;

};

#endif

