#ifndef __PHASE_FUNCTOR_H_
#define __PHASE_FUNCTOR_H_

#include "abstract_phase_functor.h"



/*!
 * \brief  derived template class for phases
 *
 * Took from http://www.newty.de/fpt/functor.html

*/
template <class TClass> class CPhaseFunctor : public APhaseFunctor
{
private:
	int (TClass::*iFPt)();   // pointer to member function
	TClass * iPt2Object;     // pointer to object

public:

	/*!
		constructor - takes pointer to an object and pointer to a member and stores
		them in two private variables
	*/
	CPhaseFunctor(TClass* aPt2Object, int (TClass::* aFPt)())
	{ 
		this->iPt2Object = aPt2Object;  
		this->iFPt = aFPt; 
	}

	// override function "Call"
	int Call()
	{ 
		// execute member function
		return (*this->iPt2Object.*this->iFPt)();
	}
};

#endif // __PHASE_FUNCTOR_H_
