#ifndef __PRIME_IDEAL_H__
#define __PRIME_IDEAL_H__
#include "algebraic_number_class.h"

/*!
 * \brief This class describes a prime ideal of a Dedekind domain
*/

class PrimeIdeal 
{
public:
	PrimeIdeal();
	~PrimeIdeal();

public:
	long Cp;						///<For identification
	long Index;						///<Index in FB field with the corresponding element
	long Prime;						///<The only prime number from <B>Z</B> in the prime ideal
	AlgebraicNumber *Generator;		///<A second generator of the prime ideal
	long Ramification;				///<The ramification index
	long Residual;					///<The residual degree
	long *pGenerator;				///<A number serving for computation of valuations
};

#endif
