#ifndef __TEST_SUITE_H__
#define __TEST_SUITE_H__

#include "const_debug.h"
#include <string>
#include "gmp.h"
#include "structures.h"

/*!
 *\brief  Unit test for several NFS components
 */
class CTestSuite
{
public:

	static int ControlSmoothNFSRelationsCount(std::string aSmoothRelFullFileName, long aSmooths);
	static int ControlSmoothAlgRelationsCount(std::string aSmoothRelFullFileName, long aSmooths);
	static int ControlPartialNFSRelationsCount(std::string aPartialRelFullFileName, std::string aIntFBFullFileName, std::string aAlgFBFullFileName, long aPartials, long aVertices, long aEdges, long aComponents);

	static int ControlFactorization(mpz_t aNumber, mpz_t aRemaining, nfs_fb_type * aFB, nfs_fb_type * aFBEnd);
	static int ControlFactorization(mpz_t aNumber, mpz_t aRemaining, lattice_type * aFB, lattice_type * aFBEnd, long aSpecialQ, bool aDivisible);

	static void TestPoly();
	static void TestPolyMod();
	static void TestRelations();
	static void TestPrimes();
	static void TestTimes();
	static void TestWriter();
	static void TestRewrite();
	static void TestMPF();
	static void TestCandidates();
	static void TestSieving(int argc, char *argv[]);
	static void TestMatrix(int argc, char *argv[]);

};

#endif // __TEST_SUITE_H__
