#ifndef __TYPES_H__
#define __TYPES_H__

#include "types_common.h"

///Used for storage of integer solutions
typedef 	      int isol_type; 		

/*!
	Used for representation of prime numbers. 
	Signed because of -1 and other negative values (like roots) encountered during sieving.
	Some methods are counting on that it is integer (CXMLHelper::SerializeSievingElement, 
	CXMLHelper::DeserializeSievingElement, CNFSRelation::Serialize, CNFSRelation::Deserialize,
	de/serialization of prime ideal for sieving and integer for sieving)
*/
typedef   signed  int main_sieving_type; 

/*!
	Used for algebraic number coefficients. Prevents integer overflow when sieving for larger N.
*/
typedef signed long algebraic_coeff_type;

typedef signed int		lp_c_p_type;

/*!
	Used for representation of logarithms.
	Some methods are counting on that it is unsigned char
	(de/serialization of prime ideal for sieving and integer for sieving)
*/
typedef unsigned char log_type;    

typedef 	      int nexksb_type;

///Used for going through the block of logs.
typedef          long log_walking_type;  


#endif // __TYPES_H__
