#ifndef __XML_HELPER__
#define __XML_HELPER__

#include <libxml/xmlreader.h>
#include <libxml/xmlwriter.h>
#include <libxml/chvalid.h>
#include "definitions.h"
#include "xml_definitions.h"
#include <gmp.h>
#include <time.h>
#include <string>

using namespace std;

int ParseDecimalDouble(xmlChar* aString, double& aTarget);

int ParseDecimalMpz(xmlChar* aString, mpz_t aTarget);

int ParseDecimalInt(xmlChar* aString, int& aTarget);

int ParseDecimalUnsignedInt(xmlChar* aString, unsigned int& aTarget);

int ParseDecimalLong(xmlChar* aString, long& aTarget);

int NewLine(xmlTextWriterPtr& aWriter, bool aIndent);

int DeserializeTime(xmlTextReaderPtr& aReader, const char* aMessage, bool aInfoMode);

int SerializeTime(xmlTextWriterPtr& aWriter);

int SerializeTime(xmlTextWriterPtr& aWriter, const char * aTag, time_t aTime);

int DeserializeMpz(xmlTextReaderPtr& aReader, const char* aMessage, mpz_t aTarget, bool aInfoMode);

int DeserializeSignedInt(xmlTextReaderPtr& aReader, const char* aMessage, int& aTarget, bool aInfoMode);

int DeserializeUnsignedInt(xmlTextReaderPtr& aReader, const char* aMessage, unsigned int& aTarget, bool aInfoMode);

int DeserializeSignedLong(xmlTextReaderPtr& aReader, const char* aMessage, long& aTarget, bool aInfoMode);

int SerializeMpz(xmlTextWriterPtr& aWriter, const char* aTagName, /*const char* aAttributeName,*/ mpz_t aValue);

int SerializePolynomialCoefficient(xmlTextWriterPtr& aWriter, mpz_t aValue, int aDegree);

int DeserializePolynomialCoefficient(xmlTextReaderPtr& aReader, const char* aMessage, mpz_t aTargetValue, int& aTargetDegree, bool aInfoMode);

int SerializeSignedInt(xmlTextWriterPtr& aWriter, const char* aTagName, /*const char* aAttributeName,*/ int aValue);

int SerializeDouble(xmlTextWriterPtr& aWriter, const char* aTagName, /*const char* aAttributeName,*/ double aValue);

int SerializeUnsignedInt(xmlTextWriterPtr& aWriter, const char* aTagName, /*const char* aAttributeName,*/ unsigned int aValue);

int SerializeSignedLong(xmlTextWriterPtr& aWriter, const char* aTagName, /*const char* aAttributeName,*/ long aValue);

int SerializeString(xmlTextWriterPtr& aWriter, const char* aTagName, const char* aValue);

int DeserializeString(xmlTextReaderPtr& aReader, const char* aMessage, char*& aTarget, bool aInfoMode);

int DeserializeString(xmlTextReaderPtr& aReader, const char* aMessage, string& aTarget, bool aInfoMode);

int WriteSerializatorData(xmlTextWriterPtr& aWriter, const char* aSerializatorNameVal, const char* aSerializatorVersion);

#endif

